2008-11-22  Eric Botcazou  <ebotcazou@adacore.com>

	* config/sparc/sparc.c (TARGET_ASM_OUTPUT_DWARF_DTPREL): Define
	only if HAVE_AS_SPARC_UA_PCREL is defined.

2008-11-17  Dodji Seketeli  <dodji@redhat.com>

	PR c++/27574
	* gcc/cgraph.c (cgraph_remove_node): Do not remove the body of
	  abstract functions. It might be useful to emit debugging
	  information. This is a patch from Ian Lance Taylor.
	* cgraphunit.c (cgraph_optimize): Do not cry when bodies of abstract
	  functions are still around. They are useful to output debug info.

2008-11-16  Eric Botcazou  <ebotcazou@adacore.com>

	* config/sparc/sparc.c (function_arg_vector_value): Remove 'base_mode'
	parameter.  Use DImode for computing the number of registers.
	(function_arg): Adjust for above change.
	(function_value): Likewise.

2008-11-13  Uros Bizjak  <ubizjak@gmail.com>

	Backport from mainline:
	2008-06-06  Uros Bizjak <ubizjak@gmail.com>

	PR rtl-optimization/36438
	* cse.c (fold_rtx) [ASHIFT, LSHIFTRT, ASHIFTRT]: Break out early
	for vector shifts with constant scalar shift operands.

2008-11-12  Jason Merrill  <jason@redhat.com>

	PR c++/38007
	* c-common.c (c_common_signed_or_unsigned_type): Remove C++
	special casing.

2008-11-10  Uros Bizjak  <ubizjak@gmail.com>

	Backport from mainline:
	2008-11-10  Ralph Loader  <suckfish@ihug.co.nz>

	PR middle-end/37807
	PR middle-end/37809
	* combine.c (force_to_mode): Do not process vector types.

	* rtlanal.c (nonzero_bits1): Do not process vector types.
	(num_sign_bit_copies1): Likewise.

2008-11-06  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	PR bootstrap/33100
	* config.gcc (i[34567]86-*-solaris2*): Include i386/t-crtstuff
	only with GNU ld.

2008-10-31  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/37909
	Backport from mainline:
	* config/sh/sh.c (untangle_mova): Return -1 when NEW_MOVA has
	no address.

2008-10-25  Kaz Kojima  <kkojima@gcc.gnu.org>

	Backport from mainline:
	* config/sh/t-sh: Use $(MULTILIB_CFLAGS) when compiling to
	unwind-dw2-Os-4-200.o.

2008-10-07  H.J. Lu  <hongjiu.lu@intel.com>

	Backport from mainline:
	2008-10-07  H.J. Lu  <hongjiu.lu@intel.com>

	PR middle-end/37731
	* expmed.c (expand_mult): Properly check DImode constant in
	CONST_DOUBLE.

2008-09-28  Eric Botcazou  <ebotcazou@adacore.com>

	PR middle-end/36575
	* fold-const.c (div_and_round_double) <ROUND_DIV_EXPR>: Fix typo.

2008-09-19  Uros Bizjak  <ubizjak@gmail.com>

	Backport from mainline:
	2008-09-18  Uros Bizjak  <ubizjak@gmail.com>

	PR rtl-optimization/37544
	* regrename.c (maybe_mode_change): Exit early when copy_mode
	is narrower than orig_mode and narrower than new_mode.

2008-08-29  Uros Bizjak  <ubizjak@gmail.com>

	Backport from mainline:
	2008-08-14  Christophe Saout  <christophe@saout.de>
		    Uros Bizjak  <ubizjak@gmail.com>

	PR target/37101
	* config/i386/sse.md (vec_concatv2di): Remove movlps alternative.

2008-08-06  Aldy Hernandez  <aldyh@redhat.com>

	PR middle-end/35432
	* gimplify.c (gimplify_modify_expr): Do not optimize
	zero-sized types if want_value.

2008-07-04  Alan Modra  <amodra@bigpond.net.au>

	PR target/36634
	* config/rs6000/rs6000.md (call, call_value): Don't arrange for
	pic_offset_table_rtx to be marked as used here.
	(call_nonlocal_sysv, call_value_nonlocal_sysv): Add split for
	TARGET_SECURE_PLT to "use" pic_offset_table_rtx.
	(call_nonlocal_sysv_secure, call_value_nonlocal_sysv_secure): New insn.
	(sibcall_nonlocal_sysv, sibcall_value_nonlocal_sysv): Assert
	!TARGET_SECURE_PLT.

2008-06-05  Richard Sandiford  <rdsandiford@googlemail.com>

	* config/mips/mips.c (mips_emit_loadgp): Return early if
	there is nothing do to, otherwise emit a blockage if
	!TARGET_EXPLICIT_RELOCS || current_function_profile.
	* config/mips/mips.md (loadgp_blockage): Use SI rather than DI.

2008-05-29  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-nested.c (check_for_nested_with_variably_modified): Fix typo.

2008-05-23  Marius Strobl <marius@FreeBSD.org>

	* gthr-posix.h (__gthread_active_p): Use the Solaris implementation
	for FreeBSD as well.
	* gthr-posix95.h: Likewise.

2008-05-20  Adam Nemet  <anemet@caviumnetworks.com>

	PR middle-end/36194
	* combine.c (check_conversion): Rename to check_promoted_subreg.
	Don't call record_truncated_value from here.
	(record_truncated_value): Turn it into a for_each_rtx callback.
	(record_truncated_values): New function.
	(combine_instructions): Call note_uses with
	record_truncated_values.  Change name of check_conversion to
	check_promoted_subreg.

2008-05-20  Joseph Myers  <joseph@codesourcery.com>

	* doc/install.texi2html: Generate gcc-vers.texi in $DESTDIR not
	$SOURCEDIR/include.

2008-05-19  Joseph Myers  <joseph@codesourcery.com>

	* BASE-VER: Bump.
	* DEV-PHASE: Mark as prerelease.

2008-05-19  Release Manager

	* GCC 4.2.4 released.

2008-05-12  Ian Lance Taylor  <iant@google.com>

	* flags.h (POINTER_TYPE_OVERFLOW_UNDEFINED): Define.
	* fold-const.c (fold_overflow_warning): Remove assertion.
	(pointer_may_wrap_p): New static function.
	(fold_comparison): If appropriate, test
	POINTER_TYPE_OVERFLOW_UNDEFINED, and issue an overflow warning.
	(fold_binary): Test POINTER_TYPE_OVERFLOW_UNDEFINED when
	reassociating a pointer type.
	* doc/invoke.texi (Optimize Options): Document that
	-fstrict-overflow applies to pointer wraparound.

2008-05-02  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR bootstrap/35169
	* optc-gen.awk: Work around HP-UX/IA awk bug.

2008-05-01  Richard Guenther  <rguenther@suse.de>

	PR middle-end/36093
	Backport from mainline
	2007-04-12  Richard Guenther  <rguenther@suse.de>

        * gimplify.c (canonicalize_addr_expr): To be consistent with
        gimplify_compound_lval only set operands two and three of
        ARRAY_REFs if they are not gimple_min_invariant.  This makes
        it never at this place.
        * tree-ssa-ccp.c (maybe_fold_offset_to_array_ref): Likewise.

2008-04-17  Volker Reichelt  <v.reichelt@netcologne.de>

	PR c/35744
	* attribs.c (decl_attributes): Return early on errorneous node.

	PR c/35436
	* c-format.c (init_dynamic_gfc_info): Ignore invalid locus type.

2008-04-08  Richard Guenther  <rguenther@suse.de>

	* fold-const.c (fold_widened_comparison): Do not allow
	sign-changes that change the result.

2008-04-03  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (xtensa_secondary_reload_class): Use a
	secondary input reload for subword loads from the constant pool.

2008-04-01  Joseph Myers  <joseph@codesourcery.com>

	* doc/include/gpl_v3.texi: Copy from trunk.
	* doc/gcc.texi, doc/gccint.texi: Include gpl_v3.texi instead of
	gpl.texi.
	* doc/sourcebuild.texi: Document gpl_v3.texi as well as gpl.texi.
	* Makefile.in (TEXI_GCC_FILES, TEXI_GCCINT_FILES): Include
	gpl_v3.texi instead of gpl.texi.
	(gpl.pod): New.

2008-03-31  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.c (s390_O_constraint_str): Limit the range
	for 'On' to -4G+1..-1.
	* config/s390/constraints.md: Adjust comment accordingly.

2008-03-25  Maxim Kuvyrkov  <maxim@codesourcery.com>

	Backport from mainline:
	2008-01-26  Maxim Kuvyrkov  <maxim@codesourcery.com>
	
	PR middle-end/34688
	* final.c (output_addr_const): Handle TRUNCATE.

2008-03-25  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2008-02-12  Richard Guenther  <rguenther@suse.de>

	PR middle-end/35163
	* fold-const.c (fold_widened_comparison): Use get_unwidened in
	value-preserving mode.  Disallow final truncation.

2008-03-13  David Edelsohn  <edelsohn@gnu.org>

	Backport from mainline:
	2008-01-26  David Edelsohn  <edelsohn@gnu.org>

	PR target/34794
	* config.gcc: Separate AIX 5.[23] from AIX 6.1.
	* config/rs6000/rs6000-c.c (rs6000_cpu_cpp_builtins): Define
	__LONGDOUBLE128 too.
	* config/rs6000/aix61.h: New file.

2008-03-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/35222
	* configure.ac (CONFIG_SJLJ_EXCEPTIONS): Force SJLJ exceptions
	on hpux10.
	* configure: Rebuilt.

2008-03-09  Kaz Kojima  <kkojima@gcc.gnu.org>

	Backport from mainline:
	PR target/35225
	* config/sh/sh.c (find_barrier): Don't go past 'from' argument.

2008-03-07  Joseph Myers  <joseph@codesourcery.com>

	* doc/include/texinfo.tex: Update to version 2008-03-07.10.

2008-03-06  Daniel Jacobowitz  <dan@codesourcery.com>

	* expmed.c (extract_bit_field): Always use adjust_address for MEM.

2008-03-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	Backport:
	2007-09-27  Matthias Klose  <doko@ubuntu.com>

	* config/i386/t-linux64 (MULTILIB_OSDIRNAMES): Use ../lib32 as the
	multilib osdirname if it exists.
	* config/rs6000/t-linux64 (MULTILIB_OSDIRNAMES): Likewise.

2008-02-25  Jan Beulich  <jbeulich@novell.com>

	* config/i386/netware-libgcc.exp: Add _Unwind_GetIPInfo.

2008-02-21  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR bootstrap/35273
	* config.build (build_file_translate): Set to `CMD //c' only if
	it works.
	* Makefile.in (build_file_translate): Improve comment.

2008-02-20  Richard Guenther  <rguenther@suse.de>

	PR middle-end/35265
	* builtins.c (validate_arg): If we want an INTEGER_TYPE,
	be happy with INTEGRAL_TYPE_P.

2008-02-19  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR bootstrap/35218
	* Makefile.in (build_file_translate): New.
	(gcc-vers.texi): Use it for translating $(abs_srcdir).
	* config.build (build_file_translate): Set to `CMD //c' on MinGW.
	* configure.ac (build_file_translate): Substitute it.
	* configure: Regenerate.

2008-02-16  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	PR c/28368
	* doc/invoke.texi (-std): Clarify description of -std= and -ansi.

2008-02-14  Alan Modra  <amodra@bigpond.net.au>

	PR target/34393
	* config/rs6000/rs6000.md (restore_stack_block): Force operands[1]
	to a reg.

2008-02-13  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR other/35148
	* Makefile.in (gcc-vers.texi): Use abs_srcdir for the value of
	srcdir.

2008-02-13  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

        PR 29673
	* doc/invoke.texi (Debugging Options): Remove -fdump-tree-inlined.
	Add -fdump-ipa-inline.
	
2008-02-10  H.J. Lu  <hongjiu.lu@intel.com>

	Backport from mainline:
	2007-08-06  H.J. Lu  <hongjiu.lu@intel.com>
		    Daniel Jacobowitz  <dan@codesourcery.com>

	PR target/31868
	* config.gcc (x86_64-*-freebsd*): Add i386/t-crtstuff to
	tmake_file.
	(x86_64-*-netbsd*): Likewise.
	(x86_64-*-linux*): Likewise.
	(x86_64-*-kfreebsd*-gnu): Likewise.
	(x86_64-*-knetbsd*-gnu): Likewise.
	(i[34567]86-*-solaris2.1[0-9]*): Likewise.

	* config/i386/t-linux64 (CRTSTUFF_T_CFLAGS): Removed.

	* config/i386/t-crtstuff (CRTSTUFF_T_CFLAGS): Update comments.
	Add -fno-asynchronous-unwind-tables.

	* config/t-freebsd (CRTSTUFF_T_CFLAGS_S): Add $(CRTSTUFF_T_CFLAGS).
	* config/t-libc-ok (CRTSTUFF_T_CFLAGS_S): Likewise.
	* config/t-lynx (CRTSTUFF_T_CFLAGS_S): Likewise.
	* config/t-netbsd (CRTSTUFF_T_CFLAGS_S): Likewise.
	* config/t-svr4 (CRTSTUFF_T_CFLAGS_S): Likewise.

2008-02-09  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle_end/34150
	* pa.c (legitimize_pic_address): Add REG_EQUAL note on sets with a
	pic_label_operand source.  Similarly, add a REG_LABEL note and
	update LABEL_NUSES during and after reload.

2008-02-08  Steven Bosscher  <stevenb.gcc@gmail.com>

	PR middle-end/34627
	* combine.c (simplify_if_then_else): Make sure the comparison is
	against const0_rtx when simplifying to (abs x) or (neg (abs X)).

2008-07-07  Richard Henderson  <rth@redhat.com>

	PR rtl-opt/33410
	* config/alpha/alpha.c (alpha_emit_xfloating_compare): Use an
	EXPR_LIST for the REG_EQUAL instead of a comparison with a 
	funny mode.

2008-02-07  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	PR other/32754
	* doc/options.texi (Options): Replace references to opts.sh with
	optc-gen.awk.
	* opts-common.c: Likewise.
	* optc-gen.awk: Likewise.
	* opth-gen.awk: Replace reference to opts.sh with
	opth-gen.awk.
	
2008-02-07  Ralf Corsepius  <ralf.corsepius@rtems.org>

	* config/m68k/t-rtems (MULTILIB_OPTIONS, MULTILIB_EXCEPTIONS,
	MULTILIB_MATCHES): Add -m528x, -m5307, -m5407, -mcfv4e multilibs.

2008-02-06  Ralf Corsepius  <ralf.corsepius@rtems.org>

	* config/arm/rtems-elf.h (TARGET_OS_CPP_BUILTINS): Add 
	builtin_define ("__USE_INIT_FINI__").
	* config/h8300/t-rtems (MULTILIB_OPTIONS, MULTILIB_DIRNAMES): Add
	-msx multilibs.
	* gthr-rtems.h: Remove __GTHREAD_MUTEX_INIT.

2008-02-05  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2008-01-17  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/34825
	* tree-ssa-math-opts.c (is_division_by): Do not recognize
	x / x as division to handle.

2008-02-05  Joseph Myers  <joseph@codesourcery.com>

	* doc/include/texinfo.tex: Update to version 2008-02-04.16.

2008-02-04  Richard Guenther  <rguenther@suse.de>

	PR middle-end/33631
	* expr.c (count_type_elements): Give for unions instead of
	guessing.

2008-02-04  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/fixdfdi.h (__fixunstfdi, __fixtfdi): Rearrange
	the overflow check to make it easier to read.
	(__fixtfdi): Change the type of the ll member in union
	long_double to UDItype_x.

2008-02-02  Richard Henderson  <rth@redhat.com>

	PR c/34993
	* tree.c (build_type_attribute_qual_variant): Skip TYPE_DOMAIN
	for unbounded arrays.

2008-02-02  Richard Sandiford  <rsandifo@nildram.co.uk>

	PR target/34981
	* config/mips/mips-protos.h (mips_expand_call): Return an rtx.
	(build_mips16_call_stub): Likewise.
	* config/mips/mips.h (FIRST_PSEUDO_REGISTER): Rename FAKE_CALL_REGNO
	to GOT_VERSION_REGNUM.
	(CALL_REALLY_USED_REGISTERS): Set the GOT_VERSION_REGNUM entry to 0.
	(EPILOGUE_USES): Include GOT_VERSION_REGNUM if TARGET_ABICALLS.
	* config/mips/mips.c (mips_emit_call_insn): New function.
	(mips_call_tls_get_addr): Call mips_expand_call directly.
	(mips_expand_call): Update the call to build_mips16_call_stub
	and remove a redundant condition.  Assert that MIPS16 stubs do not
	use lazy binding.  Use mips_emit_call_insn and return the call insn.
	(override_options): Allow SImode for GOT_VERSION_REGNUM.
	(build_mips16_call_stub): Use mips_emit_call_insn rather than
	emit_call_insn.  Return the call insn or null.
	(mips_avoid_hazard): Remove hazard_set handling.
	(mips_extra_live_on_entry): Include GOT_VERSION_REGNUM if
	TARGET_ABICALLS.
	* config/mips/mips.md (UNSPEC_EH_RECEIVER): Rename to...
	(UNSPEC_RESTORE_GP): ...this.
	(UNSPEC_SET_GOT_VERSION, UNSPEC_UPDATE_GOT_VERSION): New constants.
	(FAKE_CALL_REGNO): Rename to...
	(GOT_VERSION_REGNUM): ...this.
	(type): Add "ghost" value.  Add an associated insn reservation.
	(hazard_set): Remove.
	(exception_receiver): Rename to...
	(restore_gp): ...this and update the unspec identifier accordingly.
	(exception_receiver, nonlocal_got_receiver): New expanders.
	(load_call<mode>): Use GOT_VERSION_REGNUM.  Don't set
	FAKE_CALL_REGNO.  Remove hazard_set attribute.
	(set_got_version, update_got_version): New patterns.

2008-02-02  Richard Sandiford  <rsandifo@nildram.co.uk>

	PR target/31388
	PR target/34900
	* config/mips/mips.md (load_const_gp_<mode>): New insns.
	* config/mips/mips.c (gen_load_const_gp): New function.
	(mips_split_symbol): Avoid using or creating the MIPS16 GP
	pseudo register if no_new_pseudos.
	(mips16_gp_pseudo_reg): Use gen_load_const_gp.

2008-02-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	Backport:
	2007-08-02  Nathan Froyd  <froydnj@codesourcery.com>

	PR middle-end/25445
	* varasm.c (default_binds_local_p_1): Consult flag_whole_program
	if we are compiling with -fPIC.

2008-02-01  Joseph Myers  <joseph@codesourcery.com>

	* BASE-VER: Bump.
	* DEV-PHASE: Mark as prerelease.

2008-02-01  Release Manager

	* GCC 4.2.3 released.

2008-02-01  Andrew Pinski  <pinskia@gmail.com>
	    Mark Mitchell  <mark@codesourcery.com>
	    Ben Elliston  <bje@au.ibm.com>

	PR c/29326
	* doc/extend.texi (Other Builtins): Document.

2008-01-31  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	* doc/invoke.texi (-ansi): Mention explicitly corresponding -std=
	options. Minor fixes.
	(-std): Move reference to standards closer to where language
	standards are first mentioned.
	
2008-01-27  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	PR 32102
	* flags.h (warn_strict_aliasing): Remove.
	(warn_strict_overflow): Remove.
	* opts.c (warn_strict_aliasing): Remove.
	(warn_strict_overflow): Remove.
	* c-opts.c (c_common_handle_option): -Wall only sets
	-Wstrict-aliasing or -Wstrict-overflow if they are uninitialized.
	(c_common_post_options): Give default values to -Wstrict-aliasing
	and -Wstrict-overflow if they are uninitialized.
	* common.opt (Wstrict-aliasing): Specify Var and Init.
	(Wstrict-overflow): Likewise.
	
2008-01-25  Joseph Myers  <joseph@codesourcery.com>

	PR other/31955
	* doc/install.texi2html: Generate gcc-vers.texi.

2008-01-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	Backport:
	2007-11-07  Kenneth Zadeck <zadeck@naturalbridge.com>
	
	PR middle-end/33826
	* ipa-pure-const (static_execute): Added code to keep recursive
	functions from being marked as pure or const.
	* ipa-utils (searchc): Fixed comment.
	
2008-01-24  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/34931
	Backport:
	2007-01-25  Steve Ellcey  <sje@cup.hp.com>

	PR other/30182
	* config/pa/pa.c (pa_init_builtins): Set asm names for finite routines.
	* config/ia64/ia64.c (ia64_init_builtins):  Ditto.

	2007-01-26  Steve Ellcey  <sje@cup.hp.com>

	PR other/30182
	* config/pa/pa.h (TARGET_HPUX_11): New.
	* config/pa/pa-hpux11.h (TARGET_HPUX_11): New.
	* config/pa/pa.c (pa_init_builtins): Use TARGET_HPUX_11.

2008-01-24  Richard Guenther  <rguenther@suse.de>

	PR middle-end/34953
	* predict.c (apply_return_prediction): Check for empty blocks.
	(tree_estimate_probability): Likewise.

2008-01-23  Richard Guenther  <rguenther@suse.de>

	Backport from mainline
	2006-10-21  Richard Guenther  <rguenther@suse.de>

	* builtins.c (fold_builtin_classify): Fix typo.

2008-01-22  Eric Botcazou  <ebotcazou@adacore.com>

	PR rtl-optimization/34628
	* combine.c (try_combine): Stop and undo after the first combination
	if an autoincrement side-effect on the first insn has effectively
	been lost.

2008-01-22  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	Backport:
	2007-09-27  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/33436
	* expr.c (emit_group_load_1): Split constant double when destination
	length is half source length.

2008-01-22  Richard Guenther  <rguenther@suse.de>

	PR middle-end/34739
	Backport from mainline
	2008-01-16  Richard Guenther  <rguenther@suse.de>

	PR c/34768
	* c-typeck.c (common_pointer_type): Do not merge inconsistent
	type qualifiers for function types.

	2007-11-12  Richard Guenther  <rguenther@suse.de>

	PR middle-end/34070
	* fold-const.c (fold_binary): If testing for non-negative
	operands with tree_expr_nonnegative_warnv_p make sure to
	use op0 which has all (sign) conversions retained.

	2006-10-24  Richard Guenther  <rguenther@suse.de>

	PR middle-end/28796
	* builtins.c (fold_builtin_classify): Use HONOR_INFINITIES
	and HONOR_NANS instead of MODE_HAS_INFINITIES and MODE_HAS_NANS
	for deciding optimizations in consistency with fold-const.c
	(fold_builtin_unordered_cmp): Likewise.

2008-01-17  Eric Botcazou  <ebotcazou@adacore.com>

	Backport from mainline:

	2008-01-11  Eric Botcazou  <ebotcazou@adacore.com>
	PR middle-end/31309
	* expr.c (copy_blkmode_from_reg): Use a mode suited to the size
	when copying to memory.

2008-01-16  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR libgfortran/34699
	* pa-hpux.h (LINK_SPEC): Only search /lib/pa1.1 and /usr/lib/pa1.1 on
	static links.
	* pa-hpux10.h (LINK_SPEC): Likewise.
	* pa-hpux11.h (LINK_SPEC): Don't search /lib/pa1.1 and /usr/lib/pa1.1.

2008-01-14  Eric Botcazou  <ebotcazou@adacore.com>

	PR rtl-optimization/31944
	* cse.c (remove_pseudo_from_table): New function.
	(merge_equiv_classes): Use above function to remove pseudo-registers.
	(invalidate): Likewise.

2008-01-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/34762
	* reload.c (find_reloads_toplev): Use rtx_equal_p to compare x and mem.

2008-01-11  Bob Wilson  <bob.wilson@acm.org>
	
	* config/xtensa/xtensa.c (override_options): Set flag_shlib.
	
2008-01-09  Richard Guenther  <rguenther@suse.de>

	PR middle-end/34679
	* tree.c (host_integerp): Check for sizetype only if the
	type is an integer type.

2008-01-06  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.h (LINK_SPEC, CRT_BINUTILS_SPECS): Move AT90USB82 
	and AT90USB162 devices from 'avr5' to 'avr35' architecture.
	(ASM_SPEC): Add 'avr35' architecture.
	* config/avr/avr.c (avr_mcu_types): Move AT90USB82 and AT90USB162 
	devices from 'avr5' to 'avr35' architecture.
	(avr_arch_types): Add "avr23" entries.
	(avr_arch): Add 'ARCH_AVR35'.
	* config/avr/t-avr (MULTILIB_OPTIONS, MULTILIB_DIRNAMES): Add 'avr35'.
	(MULTILIB_MATCHES): Move AT90USB82 and AT90USB162 devices from 'avr5'
	to 'avr35' architecture.

2007-12-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR driver/33772
	* collect2.c (SHLIB_SUFFIX): Define if not defined.
	(write_c_file_stat): Use SHLIB_SUFFIX.
	* som.h (SHLIB_SUFFIX): Define.
	* doc/tm.texi (SHLIB_SUFFIX): Document.

2007-12-27  Gerald Pfeifer  <gerald@pfeifer.com>

	* config.gcc: Proactively add FreeBSD 10 and FreeBSD 11.

2007-12-21  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (hppa_legitimize_address): Use INT14_OK_STRICT in mask selection.

2007-12-19  Kaz Kylheku  <kaz@zeugmasystems.com>

	PR rtl-optimization/34456
	* resource.c (mark_set_resources): Use regs_invalidated_by_call
	rather than call_used_regs and global_regs.

2007-12-17  Jakub Jelinek  <jakub@redhat.com>

	PR bootstrap/34003
	* c-decl.c (merge_decls): Copy RTL from olddecl to newdecl.
	* config/pa/pa.c (pa_encode_section_info): If !first, preserve
	SYMBOL_FLAG_REFERENCED flag.

2007-12-13  Torbjorn Granlund  <tege@swox.com>

	* config/i386/i386.c (ix86_rtx_costs) [MULT]: Check op0 for
	ZERO_EXTEND when computing costs for widening multiplication.

2007-12-09  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/32889
	PR target/34091
	* pa.md: Consolidate HImode and QImode move patterns into one pattern
	each, eliminating floating-point alternatives.
	* pa-protos.h (pa_cannot_change_mode_class, pa_modes_tieable_p):
	Declare functions.
	* pa-64.h (SECONDARY_MEMORY_NEEDED): Define here.
	* pa.c (pa_secondary_reload): Use an intermediate general register
	for copies to/from floating-point register classes.  Simplify code
	SHIFT_REGS class.  Provide additional comments.
	(pa_cannot_change_mode_class, pa_modes_tieable_p): New functions.
	* pa.h (MODES_TIEABLE_P): Use pa_modes_tieable_p.
	(SECONDARY_MEMORY_NEEDED): Delete define.
	(INT14_OK_STRICT): Define.
	(MODE_OK_FOR_SCALED_INDEXING_P): Allow SFmode and DFmode when using
	soft float.
	(MODE_OK_FOR_UNSCALED_INDEXING_P): Likewise.
	(GO_IF_LEGITIMATE_ADDRESS): Use INT14_OK_STRICT in REG+D case for
	SFmode and DFmode.
	(LEGITIMIZE_RELOAD_ADDRESS): Use INT14_OK_STRICT in mask selection.
	Align DImode offsets when generating 64-bit code.
	* pa32-regs.h (VALID_FP_MODE_P): Remove QImode and HImode.
	(CANNOT_CHANGE_MODE_CLASS): Define.
	* pa64-regs.h (VALID_FP_MODE_P): Remove QImode and HImode.
	(CANNOT_CHANGE_MODE_CLASS): Define using pa_cannot_change_mode_class.

2007-11-28  Rask Ingemann Lambertsen  <rask@sygehus.dk>

	Backport from mainline:
	2007-11-26  Rask Ingemann Lambertsen  <rask@sygehus.dk>

	PR target/34174
	* config/fr30/fr30.c (fr30_move_double): Sanitize mem->reg case. Copy
	the address before it is clobbered.

2007-11-26  Uros Bizjak  <ubizjak@gmail.com>

	PR target/34215
	* config/i386/i386.md (truncdfsf2): Select SLOT_TEMP stack slot if
	virtual registers are instantiated.
	(truncxfsf2): Ditto.
	(truncxfdf2): Ditto.

2007-11-22  Matthias Klose  <doko@ubuntu.com>

	Backport from mainline:
	2007-11-17  Richard Guenther  <rguenther@suse.de>

	PR middle-end/34130
	* fold-const.c (extract_muldiv_1): Do not move negative
	constants inside ABS_EXPR.

2007-11-22  Richard Sandiford  <rsandifo@nildram.co.uk>

	PR rtl-optimization/33848
	* reload.c (subst_reloads): When replacing a LABEL_REF with a
	register, only add a REG_LABEL note if the label is the target
	of the jump.

2007-11-16  Richard Guenther  <rguenther@suse.de>

	PR middle-end/34030
	* fold-const.c (fold_binary): Use correct types for folding
	1 << X & Y to Y >> X & 1.

2007-11-08  Uros Bizjak  <ubizjak@gmail.com>

	PR target/32787
	Backport from mainline:

	2007-11-06  Rask Ingemann Lambertsen  <rask@sygehus.dk>

	* config/i386/driver-i386.c: Test for __GNUC__ instead of
	GCC_VERSION which is always defined.

2007-11-07  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/33822
	* rtl.h (REG_OFFSET): Fix comment.
	* var-tracking.c (INT_MEM_OFFSET): New macro.
	(var_mem_set): Use it.
	(var_mem_delete_and_set): Likewise.
	(var_mem_delete): Likewise.
	(same_variable_part_p): Likewise.
	(vt_get_decl_and_offset): Likewise.
	(offset_valid_for_tracked_p): New predicate.
	(count_uses): Do not track locations with invalid offsets.
	(add_uses): Likewise.
	(add_stores): Likewise.

2007-11-02  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (xtensa_expand_prologue): Put a
	REG_FRAME_RELATED_EXPR note on the last insn that sets up the stack
	pointer or frame pointer.
	* config/xtensa/xtensa.h (DWARF_UNWIND_INFO): Delete.
	(MUST_USE_SJLJ_EXCEPTIONS): Define.
	(DWARF2_UNWIND_INFO): Define.
	(INCOMING_RETURN_ADDR_RTX): Define.
	(DWARF_FRAME_RETURN_COLUMN): Define.

2007-10-31  Richard Guenther  <rguenther@suse.de>

	* Makefile.in (targhooks.o): Add $(OPTABS_H) dependency.

2007-10-29  Ian Lance Taylor  <iant@google.com>

	* ifcvt.c (noce_can_store_speculate_p): New static function.
	(noce_process_if_block): Call it.
	(find_if_header): Only call find_if_case_1 and find_if_case_2 if
	life_data_ok is set.
	(if_convert): Always compute postdominators.

2007-10-29  Janis Johnson  <janis187@us.ibm.com>

	* doc/invoke.texi (Option Summary, optimizations): Remove
	-fbounds-check.  Show that the value for options -falign-jumps,
	-falign-labels, -falign-loops, -falign-functions,
	-fsched-stalled-insns, and -fsched-stalled-insns-dep is optional.
	Break up a long line.  Add -ftree-vrp and -funit-at-a-time.
	(Option Summary, code gen options)  Add -fno-stack-limit.  Add
	missing @gol to the end of a line.
	* doc/invoke.texi (Option Summary, optimizations):
	(Optimization Options): Remove -fbounds-check, which is also
	documented under Code Generation Options.  In the descriptions for
	-fsched-stalled-insns and -fsched-stalled-insns-dep, show the
	options with and without values.  Change -fno-cprop-registers
	to -fcprop-registers to match other options, and say when it is
	enabled rather than disabled.  Remove extra index entry for
	-fno-cx-limited-range.  Add opindex for several optimization
	options, and fix typos in the opindex commands for several others.
	(Code Gen Options): Add index entry for -ftls-model.

2007-10-24  Richard Sandiford  <rsandifo@nildram.co.uk>

	PR target/33755
	* config/mips/mips.c (override_options): Always move
	flag_delayed_branch to mips_flag_delayed_branch.
	(mips_lo_sum_offset): New structure.
	(mips_hash_base, mips_lo_sum_offset_hash, mips_lo_sum_offset_eq)
	(mips_lo_sum_offset_lookup, mips_record_lo_sum)
	(mips_orphaned_high_part_p: New functions.
	(mips_avoid_hazard): Don't check INSN_P here.
	(mips_avoid_hazards): Rename to...
	(mips_reorg_process_insns): ...this.  Cope with
	!TARGET_EXPLICIT_RELOCS.  Delete orphaned high-part relocations,
	or turn them into nops.
	(mips_reorg): Remove TARGET_EXPLICIT_RELOCS check from calls to
	dbr_schedule and mips_avoid_hazards/mips_reorg_process_insns.

2007-10-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/rtl.texi (Flags): Fix MEM_SCALAR_P entry.
	Document MEM_POINTER.  Replace mentions of "integrated"
	field with "return_val".  Delete outdated stuff.

2007-10-22  Seongbae Park <seongbae.park@gmail.com>
	David S. Miller  <davem@davemloft.net>

	* df-scan.c (df_get_call_refs): Mark global registers as both a
	DF_REF_REG_USE and a non-clobber DF_REF_REG_DEF.

2007-10-22  Richard Sandiford  <rsandifo@nildram.co.uk>

	PR target/33169
	Backport from mainline:

	2006-10-29  Richard Sandiford  <richard@codesourcery.com>

	* config/mips/mips.c (mips_classify_symbol): Test DECL_WEAK as well
	as TREE_PUBLIC when deciding whether to return SYMBOL_GOT_GLOBAL.

2007-10-22  Richard Sandiford  <rsandifo@nildram.co.uk>

	Backport from mainline:

	2007-10-18  Richard Sandiford  <rsandifo@nildram.co.uk>

	* config/mips/mips.c (mips_expand_call): Use FAKE_CALL_REGNO.
	(mips_avoid_hazard): Allow multiple sets for HAZARD_DELAY,
	and pick the first.
	* config/mips/mips.md (load_call<mode>): Don't make the unspec
	depend on FAKE_CALL_REGNO.  Set FAKE_CALL_REGNO.

2007-10-20  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/linux-unwind.h (ppc_fallback_frame_state): Point
	saved CR2 offset to low 32 bits of regs->ccr rather than the whole
	64-bit register in 64-bit libgcc.

2007-10-18  Uros Bizjak  <ubizjak@gmail.com>

	PR target/32961
	* config/i386/i386.c (ix86_expand_builtin) [IX86_BUILTIN_PSLLWI128,
	IX86_BUILTIN_PSLLDI128, BUILTIN_PSLLQI128, IX86_BUILTIN_PSRAWI128,
	IX86_BUILTIN_PSRADI128, IX86_BUILTIN_PSRLWI128,
	IX86_BUILTIN_PSRLDI128, IX86_BUILTIN_PSRLQI128]: Do not require
	immediate shift value.
	* config/i386/emmintrin.h (_mm_slli_epi16, _mm_slli_epi32,
	_mm_slli_epi64, _mm_srai_epi16, _mm_srai_epi32, _mm_srli_epi16,
	_mm_srli_epi32, _mm_srli_epi64):  Enable disabled functions and
	remove equivalent macro definitions.

2007-10-18  Chen liqin  <liqin@sunnorth.com.cn>

	* config.gcc : update score-*-elf(extra_objs).
	* config/score/mac.md : Remove.
	* config/score/misc.md : Remove.
	* config/score/score7.md : Remove.
	* config/score/score-mdaux.h : Remove.
	* config/score/score-mdaux.c : Remove.
	* config/score/score-version.h : Remove.
	* config/score/score-generic.md : New.
	* config/score/score3.h : New.
	* config/score/score3.c : New.
	* config/score/score7.h : New.
	* config/score/score7.c : New.
	* config/score/mul-div.S : add flush_cache score3 support.
	* config/score/elf.h : Fix some typos.
	* config/score/score.md : merge score3 and score7 pattern.
	* config/score/score.c : use to seperate which target it used.
	* config/score/score.h : use to seperate the target macro.
	* config/score/score.opt : remove -mmac option , add -mscore3,
	-mscore3d and -march OPTION support.

2007-10-12  Zdenek Dvorak <ook@ucw.cz>

	PR tree-optimization/33714
	* tree-ssa-loop-ivopts.c (constant_multiple_of): Pass the arguments to
	division in the correct order.

2007-10-10  Joseph Myers  <joseph@codesourcery.com>

	PR c/25309
	* c-common.c (complete_array_type): Diagnose too-large arrays and
	set type to error_mark_node.

2007-10-10  Joseph Myers  <joseph@codesourcery.com>

	PR c/32295
	* c-typeck.c (default_conversion): Call require_complete_type
	before perform_integral_promotions.
	(build_unary_op): Call require_complete_type except for ADDR_EXPR.
	(build_c_cast): Call require_complete_type except for casts to
	void types.
	(convert_for_assignment): Call require_complete_type.

2007-10-10  Uros Bizjak  <ubizjak@gmail.com>

	Backport from mainline:
	2007-09-14  Uros Bizjak  <ubizjak@gmail.com>

	PR target/33438
	* config/i386/i386.md (fmodxf3): Copy operands[2] to temporary
	register when operands[2] equals operands[1].
	(dremxf3): Ditto.

	2007-09-10  Uros Bizjak  <ubizjak@gmail.com>

	PR target/33369
	* gcc/config/i386/sse.md (ashr<mode>3): Change op2 mode to SImode.
	Use 'N' operand constraint for op2.
	(lshr<mode>3): Ditto.
	(ashl<mode>3): Ditto.
	(vec_shl_<mode>): Use const_0_to_255_mul_8_operand predicate for op2.
	(vec_shr_<mode>): Use const_0_to_255_mul_8_operand predicate for op2.

	* gcc/config/i386/i386.c (ix86_expand_builtin) [IX86_BUILTIN_PSLL?128,
	IX86_BUILTIN_PSRA*?128, IX86_BUILTIN_PSRL?128]: Convert op1 to SImode.

2007-10-10  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2007-10-03  Doug Kwan  <dougkwan@google.com>
		Richard Guenther  <rguenther@suse.de>

	PR debug/31899
	* dwarf2out.c (reference_to_unused): Disable sanity checking,
	be conservative instead.

2007-10-10  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/33099
	PR tree-optimization/33381
	* tree-vrp.c (adjust_range_with_scev): Do not adjust ranges
	from pointer typed chrecs.

2007-10-08  Mark Mitchell  <mark@codesourcery.com>

	* BASE-VER: Bump.
	* DEV-PHASE: Mark as prerelease.

2007-10-07  Release Manager

	* GCC 4.2.2 released.

2007-09-25  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/32694
	2006-11-08  Roger Sayle  <roger@eyesopen.com>
	* tree-ssa-propagate.c (set_rhs): Verify tcc_comparison the same way
	as tcc_binary.
	* tree-ssa-ccp.c (fold_stmt_r) <COND_EXPR>: Use set_rhs to modify
	the condition after calling fold_binary.

2007-09-24  Jakub Jelinek  <jakub@redhat.com>

	PR debug/33316
	* dwarf2out.c (modified_type_die): Handle TYPE_DECL with NULL
	DECL_NAME.
	* dbxout.c (dbxout_type): Likewise.

2007-09-23  H.J. Lu  <hongjiu.lu@intel.com>

	* configure.ac (ld_vers): Support GNU linker version xx.xx.*
	* configure: Regenerated.

2007-09-23  Jakub Jelinek  <jakub@redhat.com>

	* configure.ac (MAKEINFO): Handle makeinfo version 4.10 and above.
	* configure: Regenerated.

2007-09-13  H.J. Lu  <hongjiu.lu@intel.com>

	PR bootstrap/33418
	* configure.ac (ld_vers): Support Linux linker.
	* configure: Regenerated.

2007-09-13  Seongbae Park <seongbae.park@gmail.com>

	* common.opt (femit-class-debug-always): Turn off by default.

2007-09-12  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (machine_function): Add vararg_a7_copy.
	(xtensa_copy_incoming_a7): Use start_sequence instead of
	push_to_sequence.  Stash insns in vararg_a7_copy for builtin_saveregs.
	(xtensa_builtin_saveregs): Place code from vararg_a7_copy at the start
	of the saveregs sequence.

2007-09-12  Richard Guenther  <rguenther@suse.de>

	PR middle-end/33382
	* tree-ssa-structalias.c (get_constraint_for_component_ref):
	Note that accesses to a whole flexible array member may not lead
	to a subvariable.

2007-09-10  Bob Wilson  <bob.wilson@acm.org>
	
	* config/xtensa/xtensa.c (xtensa_output_literal): Mask out high bits
	for floating-point values if HOST_BITS_PER_LONG > 32.  Use
	split_double instead of operand_subword.
	
2007-09-10  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.md (adddi3, adddi_carry): Delete.
	(subdi3, subdi_carry): Delete.

2007-09-07  Tobias Burnus  <burnus@net-b.de>

	PR middle-end/33321
	* doc/invoke.texi: Fix -Wstrict-overflow= table.

2007-09-06  Richard Sandiford  <richard@codesourcery.com>

	PR target/33256
	* config/mips/mips.c (mips_classify_symbolic_expression): New function.
	(mips_classify_address): Use it instead of mips_symbolic_constant_p.
	(print_operand_reloc): Likewise.

2007-09-03  Anatoly Sokolov <aesok@post.ru>

	PR target/28902
 	* config/avr/avr.h (TARGET_VTABLE_ENTRY_ALIGN): Define.

2007-09-01  Nick Clifton  <nickc@redhat.com>

	* COPYING3, COPYING3.LIB: New files.
	* tree-ssa-operands.h: Change copyright header to refer to version
	3 of the GNU General Public License and to point readers at the
	COPYING3 file and the FSF's license web page.
	* tree-vrp.c, regrename.c, attribs.c, loop-unswitch.c, sched-ebb.c,
	tree-loop-linear.c, dwarf2asm.c, tree-into-ssa.c, dwarf2asm.h,
	tree-ssa-loop-im.c, sbitmap.c, targhooks.c, tree-dump.c,
	tree-complex.c, sbitmap.h, targhooks.h, tree-dump.h, see.c,
	machmode.h, hooks.c, hooks.h, genrecog.c, tree-ssa-threadupdate.c,
	gen-protos.c, flags.h, rtlhooks.c, gencheck.c,
	tree-ssa-loop-niter.c, opts-common.c, tree-pretty-print.c, tracer.c,
	gengtype.c, mkconfig.sh, gengtype.h, tree-ssa-loop-unswitch.c,
	cgraph.c, c-lex.c, cgraph.h, libfuncs.h, cfgloopmanip.c,
	rtl-error.c, optabs.c, postreload-gcse.c, tree-ssa-loop-manip.c,
	optabs.h, genmddeps.c, defaults.h, postreload.c, value-prof.c,
	tree-ssa-loop-ch.c, tree-tailcall.c, gengenrtl.c, value-prof.h,
	genopinit.c, tree.c, tree.h, reload.c, tree-pass.h, ipa-cp.c,
	reload.h, bitmap.c, bitmap.h, tree-scalar-evolution.c,
	c-config-lang.in, tree-scalar-evolution.h, target.h, cppspec.c,
	rtlanal.c, ddg.c, lambda-mat.c, mips-tdump.c, ddg.h,tree-phinodes.c,
	mips-tfile.c, pointer-set.c, pointer-set.h, diagnostic.c, final.c,
	diagnostic.h, builtins.c, genoutput.c, gcc.c, lists.c, gcc.h,
	cfghooks.c, input.h, gensupport.c, fold-const.c, cfghooks.h,
	insn-notes.def, gensupport.h, builtin-attrs.def, sync-builtins.def,
	params.c, cfgloopanal.c, params.h, omp-low.c, tree-ssa-dse.c,
	gcov.c, cfg.c, genextract.c, ipa-reference.c, genautomata.c,
	tree-ssa-uncprop.c, toplev.c, tree-gimple.c, ipa-reference.h,
	vmsdbgout.c, errors.c, toplev.h, reorg.c, tree-gimple.h,
	tree-chrec.c, pretty-print.c, errors.h, real.c, tree-chrec.h,
	pretty-print.h, debug.c, real.h, genemit.c, c-cppbuiltin.c,
	genmultilib, debug.h, genconfig.c, cgraphunit.c, regs.h, df-scan.c,
	vec.c, hosthooks-def.h, vec.h, tree-ssa-copyrename.c, scan.c,
	builtin-types.def, tree-ssa-ccp.c, scan.h, mode-classes.def,
	haifa-sched.c, dominance.c, dojump.c, double-int.c, gcov-io.c,
	dbxout.c, builtins.def, double-int.h, dbxout.h,
	tree-ssa-loop-ivopts.c, df-core.c, mode-switching.c, gengtype-lex.l,
	tree-nomudflap.c, modulo-sched.c, c-objc-common.c, hosthooks.h,
	c-objc-common.h, caller-save.c, graph.c, ipa-pure-const.c, graph.h,
	c-format.c, cse.c, fix-header.c, c-format.h, web.c, tree-stdarg.c,
	genpeep.c, tree-stdarg.h, tree-ssa-math-opts.c, xcoffout.c,
	tree-ssa-dom.c, tree-nrv.c, xcoffout.h, tree-ssa-propagate.c,
	ipa-utils.c, tree-ssa-propagate.h, tree-ssa-alias.c, loop-init.c,
	ipa-utils.h, gimple-low.c, rtl.def, c-tree.h, tree-ssa-sink.c,
	ipa-inline.c, mkmap-symver.awk, machmode.def, c-pch.c, cfganal.c,
	global.c, alloc-pool.c, c-semantics.c, alloc-pool.h, jump.c,
	ifcvt.c, dwarf2out.c, expr.c, cfgbuild.c, tree-browser.c,
	dwarf2out.h, expr.h, longlong.h, opts.c, gcov-iov.c, opts.h,
	dwarf2.h, genattrtab.c, genconditions.c, genattr.c, optc-gen.awk,
	timevar.def, tree-ssa-loop-ivcanon.c, hard-reg-set.h, predict.c,
	tree-ssa-loop.c, host-default.c, predict.h, recog.c, recog.h,
	c-aux-info.c, tree-ssa-address.c, timevar.c, lcm.c, timevar.h,
	tree-vn.c, treestruct.def, fp-test.c, c-decl.c, tree-eh.c,
	c-errors.c, c-pretty-print.c, regmove.c, lambda-trans.c,
	c-pretty-print.h, et-forest.c, et-forest.h, local-alloc.c,
	function.c, langhooks.c, cppdefault.c, tree-vectorizer.c,
	function.h, langhooks.h, print-rtl.c, cppdefault.h, df.h,
	tree-vectorizer.h, sdbout.c, stor-layout.c, sdbout.h,
	rtlhooks-def.h, read-rtl.c, gcse.c, ipa-type-escape.c, vmsdbg.h,
	alias.c, ipa-type-escape.h, domwalk.c, alias.h, tree-if-conv.c,
	profile.c, domwalk.h, ipa.c, gccbug.in, tree-data-ref.c,
	loop-unroll.c, tree-data-ref.h, tree-flow-inline.h, mkmap-flat.awk,
	tree-vect-analyze.c, c.opt, ggc.h, opt-gather.awk, c-typeck.c,
	gimplify.c, coretypes.h, insn-addr.h, tree-ssa-phiopt.c, c-pragma.c,
	c-pragma.h, calls.c, genmodes.c, loop-doloop.c, predict.def,
	dwarf.h, tree.def, rtl-factoring.c, expmed.c, bt-load.c,
	ggc-common.c, genflags.c, tree-dfa.c, except.c, coverage.c,
	except.h, emit-rtl.c, cfgexpand.c, coverage.h, stringpool.c,
	cselib.c, emit-rtl.h, tree-cfgcleanup.c, c-opts.c, cselib.h,
	cfgcleanup.c, simplify-rtx.c, tree-ssa-pre.c, explow.c,
	tree-ssa-live.c, tree-sra.c, tree-ssa-live.h, loop-invariant.c,
	genpreds.c, protoize.c, opth-gen.awk, c-dump.c, lambda.h, loop-iv.c,
	tree-mudflap.c, ipa-prop.c, print-tree.c, tree-mudflap.h,
	tree-ssa-copy.c, ipa-prop.h, cfglayout.c, tree-ssa-forwprop.c,
	c-convert.c, cfglayout.h, common.opt, ggc-zone.c, ggc-page.c,
	c-omp.c, tree-ssa-dce.c, gencodes.c, varasm.c, tree-vect-patterns.c,
	libada-mk.in, sched-deps.c, tree-nested.c, c-ppoutput.c, tree-ssa.c,
	target-def.h, tree-ssa-loop-prefetch.c, lambda-code.c,
	omp-builtins.def, rtl.c, regclass.c, stab.def, intl.c, rtl.h,
	intl.h, tree-inline.c, conditions.h, tree-inline.h, integrate.c,
	sched-int.h, tree-iterator.c, integrate.h, tree-iterator.h,
	genchecksum.c, tree-optimize.c, output.h, tree-vect-transform.c,
	tree-object-size.c, combine.c, tree-outof-ssa.c, addresses.h,
	bb-reorder.c, resource.c, var-tracking.c, cfgloop.c, system.h,
	resource.h, ggc-none.c, tree-profile.c, cfgloop.h, c-gimplify.c,
	c-common.c, opt-functions.awk, tree-vect-generic.c, tree-flow.h,
	df-problems.c, scan-decls.c, c-common.h, config.gcc, reg-stack.c,
	tlink.c, main.c, stub-objc.c, fixproto, config.host, Makefile.in,
	gccspec.c, sched-rgn.c, vecprim.h, basic-block.h,
	tree-ssa-structalias.c, tree-ssa-structalias.h, c-common.def,
	sched-vis.c, tree-cfg.c, passes.c, genconstants.c, c-incpath.c,
	c-incpath.h, struct-equiv.c, c-parser.c, tree-ssa-reassoc.c,
	varray.c, sreal.c, varray.h, dfp.c, sreal.h, dfp.h, flow.c,
	conflict.c reg-notes.def, cfgrtl.c, config.build, gengtype-yacc.y,
	stmt.c, tree-browser.def, prefix.c, statistics.h, params.def,
	c-lang.c, gcov-dump.c, prefix.h, tree-ssanames.c, collect2.c,
	collect2.h, tree-ssa-threadedge.c, convert.c, convert.h,
	langhooks-def.h, reload1.c, tree-ssa-operands.c: Likewise.

2007-09-01  Nick Clifton  <nickc@redhat.com>

	* host-hpux.c: Change copyright header to refer to version 3 of
	the GNU General Public License and to point readers at the
	COPYING3 file and the FSF's license web page.
	* alpha/predicates.md, alpha/vms-ld.c, alpha/linux.h,
	alpha/alpha.opt, alpha/linux-elf.h, alpha/vms.h, alpha/elf.h,
	alpha/vms-unwind.h, alpha/ev4.md, alpha/ev6.md, alpha/alpha.c,
	alpha/vms-cc.c, alpha/alpha.h, alpha/sync.md, alpha/openbsd.h,
	alpha/alpha.md, alpha/alpha-modes.def, alpha/ev5.md,
	alpha/alpha-protos.h, alpha/freebsd.h, alpha/osf5.h,
	alpha/netbsd.h, alpha/vms64.h, alpha/constraints.md, alpha/osf.h,
	alpha/xm-vms.h, alpha/unicosmk.h, linux.h, frv/predicates.md,
	frv/frv.h, frv/linux.h, frv/frv.md, frv/frv.opt,
	frv/frv-modes.def, frv/frv-asm.h, frv/frv-protos.h, frv/frv-abi.h,
	frv/frv.c, s390/tpf.h, s390/s390.c, s390/predicates.md,
	s390/s390.h, s390/linux.h, s390/tpf.md, s390/tpf.opt,
	s390/2064.md, s390/2084.md, s390/s390.md, s390/s390.opt,
	s390/s390-modes.def, s390/fixdfdi.h, s390/constraints.md,
	s390/s390-protos.h, s390/s390x.h, elfos.h, dbxcoff.h,
	m32c/predicates.md, m32c/cond.md, m32c/m32c.c, m32c/minmax.md,
	m32c/blkmov.md, m32c/m32c-pragma.c, m32c/m32c.h, m32c/prologue.md,
	m32c/m32c.abi, m32c/muldiv.md, m32c/bitops.md, m32c/mov.md,
	m32c/addsub.md, m32c/m32c.md, m32c/m32c.opt, m32c/t-m32c,
	m32c/m32c-modes.def, m32c/jump.md, m32c/shift.md,
	m32c/m32c-protos.h, libgloss.h, interix.h, sparc/hypersparc.md,
	sparc/predicates.md, sparc/linux.h, sparc/sp64-elf.h,
	sparc/supersparc.md, sparc/cypress.md, sparc/openbsd1-64.h,
	sparc/openbsd64.h, sparc/niagara.md, sparc/sparc.md,
	sparc/long-double-switch.opt, sparc/ultra3.md, sparc/sparc.opt,
	sparc/sync.md, sparc/sp-elf.h, sparc/sparc-protos.h,
	sparc/ultra1_2.md, sparc/biarch64.h, sparc/sparc.c,
	sparc/little-endian.opt, sparc/sysv4-only.h, sparc/sparc.h,
	sparc/linux64.h, sparc/freebsd.h, sparc/sol2.h, sparc/rtemself.h,
	sparc/netbsd-elf.h, sparc/sparc-modes.def, sparc/sparclet.md,
	sparc/sysv4.h, vx-common.h, netbsd-aout.h, m32r/m32r.md,
	m32r/predicates.md, m32r/little.h, m32r/m32r.c, m32r/m32r.opt,
	m32r/linux.h, m32r/m32r.h, m32r/m32r-protos.h, vxworks.opt,
	darwin-c.c, darwin.opt, i386/i386.h, i386/cygming.h, i386/linux.h,
	i386/cygwin.h, i386/i386.md, i386/netware-crt0.c, i386/sco5.h,
	i386/mmx.md, i386/kaos-i386.h, i386/winnt-stubs.c,
	i386/netbsd64.h, i386/djgpp.h, i386/gas.h, i386/sol2.h,
	i386/constraints.md, i386/netware-libgcc.c, i386/sysv5.h,
	i386/predicates.md, i386/x86-64.h, i386/kfreebsd-gnu.h,
	i386/freebsd64.h, i386/vxworksae.h, i386/pentium.md, i386/lynx.h,
	i386/i386elf.h, i386/rtemself.h, i386/netbsd-elf.h, i386/ppro.md,
	i386/k6.md, i386/netware.c, i386/netware.h, i386/i386-modes.def,
	i386/sysv4-cpp.h, i386/i386-interix.h, i386/cygwin1.c,
	i386/djgpp.opt, i386/uwin.h, i386/unix.h, i386/ptx4-i.h,
	i386/xm-djgpp.h, i386/att.h, i386/winnt.c, i386/beos-elf.h,
	i386/sol2-10.h, i386/darwin64.h, i386/sse.md, i386/i386.opt,
	i386/bsd.h, i386/cygming.opt, i386/xm-mingw32.h, i386/linux64.h,
	i386/openbsdelf.h, i386/xm-cygwin.h, i386/sco5.opt, i386/darwin.h,
	i386/mingw32.h, i386/winnt-cxx.c, i386/i386-interix3.h,
	i386/nwld.c, i386/nwld.h, i386/host-cygwin.c, i386/cygwin2.c,
	i386/i386-protos.h, i386/sync.md, i386/openbsd.h,
	i386/host-mingw32.c, i386/i386-aout.h, i386/nto.h,
	i386/biarch64.h, i386/i386-coff.h, i386/freebsd.h,
	i386/driver-i386.c, i386/knetbsd-gnu.h, i386/host-i386-darwin.c,
	i386/vxworks.h, i386/crtdll.h, i386/i386.c, i386/sysv4.h,
	darwin-protos.h, linux.opt, sol2.c, sol2.h, sh/symbian.c,
	sh/sh-protos.h, sh/linux.h, sh/elf.h, sh/superh.h, sh/sh4.md,
	sh/coff.h, sh/newlib.h, sh/embed-elf.h, sh/symbian-pre.h,
	sh/rtems.h, sh/kaos-sh.h, sh/sh4a.md, sh/sh64.h, sh/sh.opt,
	sh/symbian-post.h, sh/sh-c.c, sh/predicates.md, sh/sh.c, sh/sh.h,
	sh/shmedia.md, sh/sh-modes.def, sh/little.h, sh/sh1.md,
	sh/superh64.h, sh/rtemself.h, sh/netbsd-elf.h, sh/sh.md,
	sh/vxworks.h, usegas.h, svr3.h, pdp11/pdp11-protos.h,
	pdp11/2bsd.h, pdp11/pdp11.md, pdp11/pdp11.c, pdp11/pdp11.opt,
	pdp11/pdp11-modes.def, pdp11/pdp11.h, avr/rtems.h,
	avr/avr-protos.h, avr/predicates.md, avr/constraints.md,
	avr/avr.md, avr/avr.c, avr/avr.opt, avr/avr.h, sol2-protos.h,
	dbxelf.h, lynx.opt, crx/crx.h, crx/crx-protos.h, crx/crx.md,
	crx/crx.c, crx/crx.opt, c4x/c4x-c.c, c4x/c4x.c, c4x/c4x.opt,
	c4x/c4x-modes.def, c4x/rtems.h, c4x/predicates.md, c4x/c4x.h,
	c4x/c4x-protos.h, c4x/c4x.md, kfreebsd-gnu.h,
	xtensa/predicates.md, xtensa/xtensa.c, xtensa/linux.h,
	xtensa/xtensa.h, xtensa/elf.h, xtensa/xtensa.md,
	xtensa/xtensa.opt, xtensa/xtensa-protos.h, dbx.h,
	stormy16/predicates.md, stormy16/stormy16.md, stormy16/stormy16.c,
	stormy16/stormy16.opt, stormy16/stormy16.h,
	stormy16/stormy16-protos.h, host-solaris.c, fr30/fr30.h,
	fr30/predicates.md, fr30/fr30-protos.h, fr30/fr30.md, fr30/fr30.c,
	fr30/fr30.opt, vxworksae.h, sol2-c.c, lynx.h,
	m68hc11/m68hc11-protos.h, m68hc11/predicates.md,
	m68hc11/m68hc11.md, m68hc11/m68hc11.c, m68hc11/m68hc11.opt,
	m68hc11/m68hc11.h, m68hc11/m68hc12.h, openbsd-oldgas.h,
	host-linux.c, interix3.h, cris/cris.c, cris/predicates.md,
	cris/linux.h, cris/cris.h, cris/aout.h, cris/cris.md,
	cris/linux.opt, cris/cris.opt, cris/elf.opt, cris/aout.opt,
	cris/cris-protos.h, netbsd.h, netbsd-elf.h, iq2000/iq2000.h,
	iq2000/predicates.md, iq2000/iq2000-protos.h, iq2000/iq2000.md,
	iq2000/iq2000.c, iq2000/iq2000.opt, host-darwin.c, mt/mt.md,
	mt/mt.c, mt/mt.opt, mt/t-mt, mt/mt.h, mt/mt-protos.h, svr4.h,
	host-darwin.h, chorus.h, mn10300/mn10300.c, mn10300/mn10300.opt,
	mn10300/predicates.md, mn10300/mn10300.h, mn10300/linux.h,
	mn10300/mn10300-protos.h, mn10300/mn10300.md, ia64/predicates.md,
	ia64/itanium1.md, ia64/unwind-ia64.h, ia64/ia64-c.c, ia64/sync.md,
	ia64/ia64.c, ia64/itanium2.md, ia64/ia64.h, ia64/vect.md,
	ia64/freebsd.h, ia64/ia64.md, ia64/ia64-modes.def, ia64/hpux.h,
	ia64/ia64-protos.h, windiss.h, gofast.h, rtems.h, sol2-10.h,
	m68k/predicates.md, m68k/m68k.md, m68k/linux.h,
	m68k/m68k-modes.def, m68k/m68k-protos.h, m68k/coff.h,
	m68k/m68k-none.h, m68k/ieee.opt, m68k/openbsd.h, m68k/m68k-aout.h,
	m68k/m68k.opt, m68k/m68020-elf.h, m68k/m68kelf.h, m68k/m68k.c,
	m68k/rtemself.h, m68k/netbsd-elf.h, m68k/m68k.h, m68k/uclinux.h,
	rs6000/power4.md, rs6000/host-darwin.c, rs6000/6xx.md,
	rs6000/linux.h, rs6000/eabi.h, rs6000/aix41.opt, rs6000/xcoff.h,
	rs6000/secureplt.h, rs6000/linuxspe.h, rs6000/eabialtivec.h,
	rs6000/8540.md, rs6000/darwin8.h, rs6000/kaos-ppc.h,
	rs6000/windiss.h, rs6000/603.md, rs6000/aix41.h, rs6000/mpc.md,
	rs6000/aix43.h, rs6000/beos.h, rs6000/gnu.h, rs6000/rtems.h,
	rs6000/aix.opt, rs6000/darwin.md, rs6000/darwin64.h,
	rs6000/default64.h, rs6000/7xx.md, rs6000/darwin.opt,
	rs6000/spe.md, rs6000/rs6000.opt, rs6000/rs6000-c.c,
	rs6000/rios2.md, rs6000/linuxaltivec.h, rs6000/7450.md,
	rs6000/linux64.h, rs6000/constraints.md, rs6000/440.md,
	rs6000/darwin.h, rs6000/host-ppc64-darwin.c, rs6000/rs6000.c,
	rs6000/aix52.h, rs6000/rs6000.h, rs6000/predicates.md,
	rs6000/altivec.md, rs6000/aix64.opt, rs6000/rios1.md,
	rs6000/rs6000-modes.def, rs6000/rs64.md, rs6000/eabisim.h,
	rs6000/sysv4le.h, rs6000/darwin7.h, rs6000/linux64.opt,
	rs6000/sync.md, rs6000/vxworksae.h, rs6000/power5.md,
	rs6000/lynx.h, rs6000/biarch64.h, rs6000/rs6000.md,
	rs6000/sysv4.opt, rs6000/eabispe.h, rs6000/freebsd.h,
	rs6000/rs6000-protos.h, rs6000/netbsd.h, rs6000/e500-double.h,
	rs6000/aix.h, rs6000/vxworks.h, rs6000/40x.md, rs6000/aix51.h,
	rs6000/sysv4.h, arc/arc-protos.h, arc/arc.md, arc/arc.c,
	arc/arc.opt, arc/arc-modes.def, arc/arc.h, mcore/mcore-elf.h,
	mcore/mcore-protos.h, mcore/predicates.md, mcore/mcore.md,
	mcore/mcore.c, mcore/mcore.opt, mcore/mcore.h, mcore/mcore-pe.h,
	darwin.c, freebsd-nthr.h, score/predicates.md,
	score/score-version.h, score/score-protos.h, score/misc.md,
	score/elf.h, score/score.c, score/mac.md, score/score7.md,
	score/score.h, score/score-conv.h, score/score-mdaux.c,
	score/score.md, score/score.opt, score/score-modes.def,
	score/score-mdaux.h, score/mul-div.S, arm/uclinux-elf.h,
	arm/semi.h, arm/ecos-elf.h, arm/arm1020e.md, arm/symbian.h,
	arm/linux-elf.h, arm/arm1026ejs.md, arm/arm1136jfs.md, arm/elf.h,
	arm/aout.h, arm/arm.c, arm/coff.h, arm/strongarm-pe.h, arm/arm.h,
	arm/semiaof.h, arm/arm-modes.def, arm/linux-eabi.h,
	arm/rtems-elf.h, arm/arm-cores.def, arm/arm-protos.h, arm/vfp.md,
	arm/aof.h, arm/linux-gas.h, arm/wince-pe.h, arm/constraints.md,
	arm/xscale-elf.h, arm/strongarm-coff.h, arm/arm.opt,
	arm/arm926ejs.md, arm/predicates.md, arm/iwmmxt.md,
	arm/unknown-elf.h, arm/kaos-arm.h, arm/bpabi.h, arm/pe.opt,
	arm/arm.md, arm/xscale-coff.h, arm/pe.c, arm/arm-generic.md,
	arm/pe.h, arm/kaos-strongarm.h, arm/freebsd.h, arm/netbsd.h,
	arm/fpa.md, arm/strongarm-elf.h, arm/cirrus.md, arm/netbsd-elf.h,
	arm/vxworks.h, kaos.h, pa/predicates.md, pa/pa64-hpux.h,
	pa/pa-hpux.opt, pa/som.h, pa/pa-hpux1010.opt, pa/pa-hpux1111.opt,
	pa/pa-pro-end.h, pa/elf.h, pa/fptr.c, pa/pa64-linux.h, pa/pa.md,
	pa/pa.opt, pa/pa-hpux.h, pa/pa-hpux10.h, pa/pa-hpux11.h,
	pa/pa-hpux1010.h, pa/pa-protos.h, pa/pa-osf.h, pa/pa-hpux1111.h,
	pa/pa-64.h, pa/milli64.S, pa/pa.c, pa/pa-linux.h, pa/pa.h,
	pa/pa32-linux.h, pa/pa64-hpux.opt, pa/pa64-regs.h,
	pa/pa-modes.def, darwin9.h, mips/4100.md, mips/linux.h,
	mips/elf.h, mips/sdb.h, mips/windiss.h, mips/rtems.h,
	mips/3000.md, mips/iris5.h, mips/5000.md, mips/7000.md,
	mips/9000.md, mips/4600.md, mips/linux64.h, mips/elforion.h,
	mips/constraints.md, mips/generic.md, mips/predicates.md,
	mips/4300.md,mips/mips-ps-3d.md, mips/iris.h, mips/24k.md,
	mips/mips.md, mips/mips.opt, mips/4k.md, mips/5k.md,
	mips/vr4120-div.S, mips/openbsd.h, mips/iris6.h, mips/4000.md,
	mips/mips-protos.h, mips/6000.md, mips/mips.c, mips/mips.h,
	mips/r3900.h, mips/netbsd.h, mips/vxworks.h, mips/mips-modes.def,
	mips/vr.h, soft-fp/t-softfp, openbsd.h, ptx4.h, freebsd-spec.h,
	vax/vax.c, vax/openbsd.h, vax/vax.h, vax/elf.h, vax/vax.md,
	vax/bsd.h, vax/vax.opt, vax/vax-modes.def, vax/openbsd1.h,
	vax/netbsd.h, vax/vax-protos.h, vax/netbsd-elf.h, vax/vaxv.h,
	vax/ultrix.h, freebsd.h, h8300/rtems.h, h8300/predicates.md,
	h8300/h8300.c, h8300/h8300.h, h8300/elf.h, h8300/h8300.md,
	h8300/h8300.opt, h8300/coff.h, h8300/h8300-protos.h, v850/v850.md,
	v850/predicates.md, v850/v850-c.c, v850/v850.c, v850/v850.opt,
	v850/v850.h, v850/v850-protos.h, knetbsd-gnu.h, sol2-6.h,
	vxworks.h, mmix/mmix.h, mmix/predicates.md, mmix/mmix-protos.h,
	mmix/mmix.md, mmix/mmix.c, mmix/mmix.opt, mmix/mmix-modes.def,
	bfin/bfin.opt, bfin/rtems.h, bfin/bfin-modes.def,
	bfin/predicates.md, bfin/bfin-protos.h, bfin/bfin.c, bfin/bfin.h,
	bfin/bfin.md: Likewise.

2007-08-31  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/33148
	* simplify-rtx.c (simplify_unary_operation_1): Only optimize
	(neg (lt X 0)) if X has scalar int mode.

	PR debug/32914
	* dwarf2out.c (rtl_for_decl_init): If vector decl has CONSTRUCTOR
	initializer, use build_vector_from_ctor if possible to create
	VECTOR_CST out of it.  If vector initializer is not VECTOR_CST
	even after this, return NULL.

2007-08-27  Jason Merrill  <jason@redhat.com>

	PR c++/31337
	* gimplify.c (gimplify_modify_expr): Discard the assignment of 
	zero-sized types after calling gimplify_modify_expr_rhs.

2007-08-24  Jakub Jelinek  <jakub@redhat.com>

	PR debug/32610
	* dwarf2out.c (gen_decl_die): Don't call
	gen_tagged_type_instantiation_die if decl doesn't have tagged type.

2007-08-24  Richard Guenther  <rguenther@suse.de>

	* expr.c (get_inner_reference): Remove unused variable.

2007-08-24  Richard Guenther  <rguenther@suse.de>

	* expr.c (get_inner_reference): Do computation of bitoffset
	from offset in a way we can detect overflow reliably.

2007-08-22  Richard Guenther  <rguenther@suse.de>

	PR middle-end/32563
	* tree.c (host_integerp): Treat sizetype as signed as it is
	sign-extended.

2007-08-20  Adam Nemet  <anemet@caviumnetworks.com>

	* config/mips/predicates.md (const_call_insn_operand): Invoke
	SYMBOL_REF_LONG_CALL_P only on SYMBOL_REFs.

2007-08-17  Chen liqin  <liqin@sunnorth.com.cn>

	* config/score/score.md : Update pattern tablejump.
	* config/score/score.c : Update score_initialize_trampoline 
	function.
	* config/score/score.h (TRAMPOLINE_TEMPLATE): Added macro.
	(TRAMPOLINE_INSNS, TRAMPOLINE_SIZE) Update macro.
	* doc/contrib.texi: Add my entry.

2007-08-02  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.md ("*xordi3_cconly"): Change xr to xg.

2007-08-01  Andreas Krebbel  <krebbel1@de.ibm.com>

	* config/s390/s390.md (TF in GPR splitter): Change operand_subword
	parameter to TFmode.

2007-07-30  Mark Mitchell  <mark@codesourcery.com>

	* BASE-VER: Bump.
	* DEV-PHASE: Mark as prerelease.

2007-07-25  Steve Ellcey  <sje@cup.hp.com>

	PR target/32218
	* tree-vect-patterns.c (vect_pattern_recog_1): Check for valid type.

2007-07-25  Dorit Nuzman  <dorit@il.ibm.com>
	    Devang Patel  <dpatel@apple.com>

	PR tree-optimization/25413
	* targhooks.c (default_builtin_vector_alignment_reachable): New.
	* targhooks.h (default_builtin_vector_alignment_reachable): New.
	* tree.h (contains_packed_reference): New.
	* expr.c (contains_packed_reference): New.
	* tree-vect-analyze.c (vector_alignment_reachable_p): New.
	(vect_enhance_data_refs_alignment): Call
	vector_alignment_reachable_p.
	* target.h (vector_alignment_reachable): New builtin.
	* target-def.h (TARGET_VECTOR_ALIGNMENT_REACHABLE): New.
	* config/rs6000/rs6000.c (rs6000_vector_alignment_reachable): New.
	(TARGET_VECTOR_ALIGNMENT_REACHABLE): Define.

2007-07-24  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2007-07-16  Richard Guenther  <rguenther@suse.de>
		    Uros Bizjak  <ubizjak@gmail.com>

	* tree-if-conv.c (find_phi_replacement_condition): Unshare "*cond"
	before forcing it to gimple operand.

2007-07-24  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/32723
	Backport from mainline:
	2007-03-09  Daniel Berlin  <dberlin@dberlin.org>

	* tree-ssa-structalias.c (shared_bitmap_info_t): New structure.
	(shared_bitmap_table): New variable.
	(shared_bitmap_hash): New function.
	(shared_bitmap_eq): Ditto
	(shared_bitmap_lookup): Ditto.
	(shared_bitmap_add): Ditto.
	(find_what_p_points_to): Rewrite to use shared bitmap hashtable.
	(init_alias_vars): Init shared bitmap hashtable.
	(delete_points_to_sets): Delete shared bitmap hashtable.

2007-07-23  Bernd Schmidt  <bernd.schmidt@analog.com>

	* reload1.c (choose_reload_regs): Set reload_spill_index for regs
	chosen during find_reloads.

2007-07-19  Release Manager

	* GCC 4.2.1 released.

2007-07-18  Paolo Bonzini  <bonzini@gnu.org>

	Revert:

	2007-07-09  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/32004
	* function.c (rest_of_match_asm_constraints): Pass PROP_REG_INFO.

	2007-07-06  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/32004
	* function.c (match_asm_constraints_1, rest_of_match_asm_constraints,
	pass_match_asm_constraints): New.
	* passes.c (init_optimization_passes): Add new pass.
	* stmt.c (expand_asm_operands): Set cfun->has_asm_statement.
	* function.h (struct function): Add has_asm_statement bit.
	(current_function_has_asm_statement): New.
	* tree-pass.h (pass_match_asm_constraints): New.

2007-07-16  Paul Brook  <paul@codesourcery.com>

	PR target/32753
	gcc/
	* config/arm/cirrus.md (cirrus_arm_movsi_insn): Remove dead insn.

2007-07-10  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	PR target/32538
	* config/mips/iris6.h (LIBGCC_SPEC): Add libm.

2007-07-09  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/32004
	* function.c (rest_of_match_asm_constraints): Pass PROP_REG_INFO.

2007-07-09  Uros Bizjak  <ubizjak@gmail.com>

	PR tree-optimization/32681
	* tree-if-conv.c (find_phi_replacement_condition): Use the condition
	saved in second_edge->aux when first_bb is a loop header.

2007-07-07 Anatoly Sokolov <aesok@post.ru>

	PR target/31331
	* config/avr/avr.c (avr_naked_function_p): Handle receiving a type
	rather than a decl. 
	(avr_attribute_table): Make "naked" attribute apply to function types
	rather than to decls.
	(avr_handle_fntype_attribute): New function.

2007-07-06  Paolo Bonzini  <bonzini@gnu.org>

	PR middle-end/32004
	* function.c (match_asm_constraints_1, rest_of_match_asm_constraints,
	pass_match_asm_constraints): New.
	* passes.c (init_optimization_passes): Add new pass.
	* stmt.c (expand_asm_operands): Set cfun->has_asm_statement.
	* function.h (struct function): Add has_asm_statement bit.
	(current_function_has_asm_statement): New.
	* tree-pass.h (pass_match_asm_constraints): New.

2007-07-06  Uros Bizjak  <ubizjak@gmail.com>

	PR rtl-optimization/32450
	* function.c (thread_prologue_and_epilogue_insns): Emit blockage insn
	to ensure that instructions are not moved into the prologue when
	profiling is on.

2007-07-04  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/32500
	* tree-ssa-loop-niter.c (infer_loop_bounds_from_undefined):
	Only use basic blocks that are always executed to infer loop bounds.

2007-07-04  Uros Bizjak  <ubizjak@gmail.com>

	PR tree-optimization/31966
	PR tree-optimization/32533
	* tree-if-conv.c (add_to_dst_predicate_list): Use "edge", not
	"basic_block" description as its third argument.  Update function
	calls to get destination bb from "edge" argument.  Save "cond" into
	aux field of the edge.  Update prototype for changed arguments.
	(if_convertible_loop_p): Clear aux field of incoming edges if bb
	contains phi node.
	(find_phi_replacement_condition): Operate on incoming edges, not
	on predecessor blocks.  If there is a condition saved in the
	incoming edge aux field, AND it with incoming bb predicate.
	Return source bb of the first edge.
	(clean_predicate_lists): Clean aux field of outgoing node edges.
	(tree_if_conversion): Do not initialize cond variable. Move
	variable declaration into the loop.
	(replace_phi_with_cond_gimple_modify_stmt): Remove unneded
	initializations of new_stmt, arg0 and arg1 variables.

2007-07-04  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/32506
	Backport from mainline.
	* config/sh/sh.md (udivsi3_i1_media): Use target_reg_operand
	predicate instead of target_operand.
	(divsi3_i1_media, divsi3_media_2): Likewise.

2007-07-03  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2006-12-11  Zdenek Dvorak <dvorakz@suse.cz>

	PR rtl-optimization/30113
	* loop-iv.c (implies_p): Require the mode of the operands to be
	scalar.

2007-07-03  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	PR target/28307
	* gthr-posix.h [SUPPORTS_WEAK && GTHREAD_USE_WEAK]
	(__gthrw_pragma): Provide default definition.
	(__gthrw2): Use it.
	* gthr-posix.c (__gthrw_pragma): Define.

2007-07-02  Jakub Jelinek  <jakub@redhat.com>

	PR libgomp/32468
	* omp-low.c (check_combined_parallel): New function.
	(lower_omp_parallel): Call it via walk_stmts, set
	OMP_PARALLEL_COMBINED if appropriate.
	(determine_parallel_type): If OMP_FOR resp. OMP_SECTIONS
	isn't the only statement in WS_ENTRY_BB or OMP_RETURN
	the only one in PAR_EXIT_BB and not OMP_PARALLEL_COMBINED,
	don't consider it as combined parallel.

2007-06-30  Alexandre Oliva  <aoliva@redhat.com>

	* dwarf2out.c (dwarf2out_finish): Accept namespaces as context of
	limbo die nodes.

2007-06-28  Seongbae Park  <seongbae.park@gmail.com>

	* config/arm/arm.c (arm_get_frame_offsets): Set
	offsets->locals_base to avoid negative stack size.
	(thumb_expand_prologue): Assert on negative stack size.

2007-06-28  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.c (rs6000_function_ok_for_sibcall): Ensure
	decl is non-external for AIX ABI.

2007-06-28  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/predicates.md (current_file_function_operand):
	Ensure the symbol is non-external for AIX ABI.

2007-06-21  H.J. Lu  <hongjiu.lu@intel.com>

	* config/i386/i386.c (ix86_builtins): Add IX86_BUILTIN_VEC_EXT_V16QI.
	(ix86_init_mmx_sse_builtins): Add __builtin_ia32_vec_ext_v16qi.
	(ix86_expand_builtin): Handle IX86_BUILTIN_VEC_EXT_V16QI.

2007-06-21  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/32362
	* omp-low.c (lookup_decl_in_outer_ctx): Don't ICE if t is NULL,
	but decl is a global var, instead return decl.
	* gimplify.c (gimplify_adjust_omp_clauses_1): Add shared clauses
	even for is_global_var decls, if they are private in some outer
	context.

2007-06-21  Uros Bizjak  <ubizjak@gmail.com>

	PR target/32389
	* config/i386/i386.h (enum ix86_stack_slot): Add SLOT_VIRTUAL.
	* config/i386/i386.c (assign_386_stack_local): Assert that
	SLOT_VIRTUAL is valid only before virtual regs are instantiated.
	(ix86_expand_builtin) [IX86_BUILTIN_LDMXCSR, IX86_BUILTIN_STMXCSR]:
	Use SLOT_VIRTUAL stack slot instead of SLOT_TEMP.
	* config/i386/i386.md (truncdfsf2, truncxfsf2, truncxfdf2): Ditto.

2007-06-20  Jakub Jelinek  <jakub@redhat.com>

	PR inline-asm/32109
	* gimplify.c (gimplify_asm_expr): Issue error if type is addressable
	and !allows_mem.

	PR middle-end/32285
	* calls.c (precompute_arguments): Also precompute CALL_EXPR arguments
	if ACCUMULATE_OUTGOING_ARGS.

2007-06-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR rtl-optimization/28011
	Backport from mainline.
	* reload.c (push_reload): Set dont_share if IN appears in OUT
	also when IN is a PLUS rtx.
	(reg_overlap_mentioned_for_reload_p): Return true if X and IN
	are same PLUS rtx.

2007-06-19  Richard Guenther  <rguenther@suse.de>
	Michael Matz  <matz@suse.de>

	PR tree-optimization/30252
	* tree-ssa-structalias.c (solution_set_add): Make sure to
	preserve all relevant vars.
	(handle_ptr_arith): Make sure to only handle positive
	offsets.
	(push_fields_onto_fieldstack): Create fields for empty
	bases.

2007-06-19  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/32353
	* tree-ssa-structalias.c (set_uids_in_ptset): Also handle RESULT_DECL.

2007-06-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (sparc_vis_init_builtins): Retrieve the
	return mode from the builtin itself.
	(sparc_fold_builtin): Fix cast of zero constant.

2007-06-15  Diego Novillo  <dnovillo@google.com>

	PR 32327
	* tree-ssa-operands.c (build_ssa_operands): Initially assume
	that the statement does not take any addresses.

2007-06-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (sparc_override_options): Initialize
	fpu mask correctly.

2007-06-09  Ian Lance Taylor  <iant@google.com>

	PR tree-optimization/32169
	* tree-vrp.c (extract_range_from_unary_expr): For NOP_EXPR and
	CONVERT_EXPR, check whether min and max both converted to an
	overflow infinity representation.

2007-06-08  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/32163
	Backport from mainline.
	* config/sh/sh.md (symGOT_load): Don't schedule insns when
	the symbol is generated with the stack protector.

2007-06-06  Ian Lance Taylor  <iant@google.com>

	* fold-const.c (merge_ranges): If range_successor or
	range_predecessor fail, just return 0.

2007-06-05  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c (compare_values_warnv): Check TREE_NO_WARNING on a
	PLUS_EXPR or MINUS_EXPR node before setting *strict_overflow_p.
	(extract_range_from_assert): Set TREE_NO_WARNING when creating an
	expression.
	(test_for_singularity): Likewise.

2007-06-04  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c (adjust_range_with_scev): When loop is not expected
	to overflow, reduce overflow infinity to regular infinity.
	(vrp_var_may_overflow): New static function.
	(vrp_visit_phi_node): Check vrp_var_may_overflow.

2007-05-31  H.J. Lu  <hongjiu.lu@intel.com>

	Backport from mainline:
	2007-05-25  H.J. Lu  <hongjiu.lu@intel.com>

	* config/i386/i386.c (__builtin_ia32_vec_ext_v2df): Mark it
	with MASK_SSE2.
	(__builtin_ia32_vec_ext_v2di): Likewise.
	(__builtin_ia32_vec_ext_v4si): Likewise.
	(__builtin_ia32_vec_ext_v8hi): Likewise.
	(__builtin_ia32_vec_set_v8hi): Likewise.

2007-05-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	Backport from mainline:
	2007-05-05  Aurelien Jarno  <aurelien@aurel32.net>

	* config/pa/pa.md: Split tgd_load, tld_load and tie_load
	into pic and non-pic versions. Mark r19 as used for 
	tgd_load_pic, tld_load_pic and tie_load_pic. Mark r27 as used 
	for tgd_load, tld_load and tie_load .
	* config/pa/pa.c (legitimize_tls_address): Emit pic or non-pic
	version of tgd_load, tld_load and tie_load depending on the 
	value of flag_pic.

2007-05-27  Daniel Berlin <dberlin@dberlin.org>

	Fix PR/30052
	Backport PTA solver from mainline

	* pointer-set.c: Copy from mainline
	* pointer-set.h: Ditto.
	* tree-ssa-structalias.c: Copy solver portions from mainline.
	* Makefile.in (tree-ssa-structalias.o): Update dependencies

2007-05-30  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tree-vrp.c (compare_names): Initialize sop.

2007-05-30  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/31769
	* except.c (duplicate_eh_regions): Clear prev_try if
	ERT_MUST_NOT_THROW region is inside of ERT_TRY region.

2007-05-28  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/32100
	* fold-const.c (tree_expr_nonnegative_warnv_p): Don't
	return true when truth_value_p is true and the type
	is of signed:1.

2007-05-27  H.J. Lu  <hongjiu.lu@intel.com>

	Backport from mainline:
	2007-05-25  Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/sse.md (*vec_extractv2di_1_sse2): Do not calculate
	"memory" attribute for "sseishft" type insn without operands[2].

	2007-05-25  H.J. Lu  <hongjiu.lu@intel.com>

	* config/i386/sse.md (*vec_extractv2di_1_sse2): Correct shift.

2007-05-22  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c (avoid_overflow_infinity): New static function,
	broken out of set_value_range_to_value.
	(set_value_range_to_value): Call avoid_overflow_infinity.
	(extract_range_from_assert): Likewise.

2007-05-23  Chen Liqin  <liqin@sunnorth.com.cn>

	PR target/30987
	* config/score/misc.md (bitclr_c, bitset_c, bittgl_c): remove.
	* config/score/predicate.md (const_pow2, const_npow2): remove.
	* config/score/score.h (ASM_OUTPUT_EXTERNAL): add ASM_OUTPUT_EXTERNAL undef.
	PR target/30474
	* config/score/score.c (score_print_operand): makes sure that only lower 
	bits are used.
	
2007-05-21  Uros Bizjak  <ubizjak@gmail.com>

	PR target/31167
	Backport from mainline.
	* config/i386/i386.md (*addti3_1, *addti3_1 splitter): Use
	x86_64_general_operand as operand[2] predicate.  Remove "iF"
	from operand constraints and use "e" constraint instead.
	(*subti3_1, *subti3_1 splitter): Ditto.
	(*negti2_1, *negti2_1 splitter): Use nonimmediate_operand as
	operand[1] predicate.

2007-05-21  Uros Bizjak  <ubizjak@gmail.com>

	PR target/30041
	Backport from mainline.
	* config/i386/sse.md ("*sse3_movddup"): Use operands[0] and
	operands[1] in insn constraint.  Correct type attribute to sselog1.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31701
	Backport from mainline.
	* config/sh/sh.c (output_stack_adjust): Avoid using the frame
	register itself to hold the offset constant.  Tell flow the use
	of r4 and r5 when they are used.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31480
	Backport from mainline.
	* config/sh/sh.md (length): Check if prev_nonnote_insn (insn)
	is null.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/31022
	Backport from mainline.
	* config/sh/sh.c (sh_adjust_cost): Use the result of single_set
	instead of PATTERN.

2007-05-20  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR target/27405
	Backport from mainline.
	* config/sh/sh.md (cmp{eq,gt,gtu}{si,di}_media): Remove.
	(cmpsi{eq,gt,gtu}{si,di}_media): Rename to
	cmp{eq,gt,gtu}{si,di}_media.
	(*cmpne0si_media): Remove.
	(*movsicc_umin): Adjust gen_cmp*_media call.
	(unordered): Change the mode of unordered and operands[1] to
	SImode.
	(seq): Adjust gen_cmp*_media calls.  Make the mode of
	a temporary result of compare SImode if needed.  If the mode
	of operands[0] is DImode, extend the temporary result to DImode.
	(slt, sle, sgt, sge, sgtu, sltu, sleu, sgue, sne): Likewise.
	(sunorderd): Change the mode of match_operand and unorderd to
	SImode.
	(cmpeq{sf,df}_media): Remove.
	(cmpsieq{sf,df}_media): Rename to cmpeq{sf,df}_media.
	(cmp{gt,ge,un}{sf,df}_media): Change the mode of match_operand
	and compare operation to SImode.

2007-05-18  Joseph Myers  <joseph@codesourcery.com>

	* config/soft-fp/double.h, config/soft-fp/extended.h,
	config/soft-fp/floatundidf.c, config/soft-fp/floatundisf.c,
	config/soft-fp/floatunsidf.c, config/soft-fp/floatunsisf.c,
	config/soft-fp/op-2.h, config/soft-fp/op-4.h,
	config/soft-fp/op-common.h, config/soft-fp/quad.h: Update from
	glibc CVS.

2007-05-17  Ian Lance Taylor  <iant@google.com>

	PR tree-optimization/31953
	* tree-vrp.c (set_value_range_to_value): Add equiv parameter.
	Change all callers.
	(set_value_range_to_null): Call set_value_range_to_value.
	(extract_range_from_comparison): Likewise.

2007-05-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/31691
	* combine.c (simplify_set): Build a new src pattern instead of
	substituting its operands in the COMPARE case.

2007-05-14  Mark Mitchell  <mark@codesourcery.com>

	* BASE-VER: Set to 4.2.1.
	* DEV-PHASE: Set to prerelease.

2007-05-13  Release Manager

	* GCC 4.2.0 released.

2007-05-12  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/31797
	* tree-ssa-forwprop.c (forward_propagate_addr_expr): Do not
	propagate into a stmt that has volatile ops.

2007-05-01  Ian Lance Taylor  <iant@google.com>

	PR tree-optimization/31739
	* tree-vrp.c (vrp_val_is_max): New static function.
	(vrp_val_is_min): New static function.
	(set_value_range_to_value): Use TYPE_{MAX,MIN}_VALUE rather than
	copying the node.
	(set_value_range): Use vrp_val_is_{max,min}.
	(extract_range_from_assert): Likewise.
	(extract_range_from_binary_expr): Likewise.
	(extract_range_from_unary_expr): Likewise.
	(dump_value_range, vrp_meet): Likewise.
	(vrp_visit_phi_node): Likewise.
	* tree.c (build_distinct_type_copy): Revert change of 2007-04-27.

2007-05-01  Joseph Myers  <joseph@codesourcery.com>

	* config/rs6000/libgcc-ppc-glibc.ver (__gcc_qgt): Fix typo.

2007-04-27  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (avr_mcu_types): Add support for ATmega8HVA and 
	ATmega16HVA devices. Move AT90USB82 device to 'avr5' architecture.
	* config/avr/avr.h (LINK_SPEC, CRT_BINUTILS_SPECS): (Ditto.).
	* config/avr/t-avr (MULTILIB_MATCHES): (Ditto.).

2007-04-27  Ian Lance Taylor  <iant@google.com>

	PR middle-end/31710
	* tree.c (build_distinct_type_copy): If TYPE_MIN_VALUE or
	TYPE_MAX_VALUE exist, convert them to the new type.

2007-04-26  Ian Lance Taylor  <iant@google.com>

	PR target/28675
	* reload.c (find_reloads_subreg_address): If the address was valid
	in the original mode but not in the new mode, reload the whole
	address.

2007-04-26  Ulrich Weigand  <uweigand@de.ibm.com>

	PR middle-end/30761
	* reload1.c (eliminate_regs_in_insn): In the single_set special
	case, attempt to re-recognize the insn before falling back to
	having reload fix it up.

2007-04-26  Richard Guenther  <rguenther@suse.de>
	Daniel Berlin  <dberlin@dberlin.org>

	PR tree-optimization/30567
	* tree-ssa-structalias.c (update_alias_info): Record dereference
	also if ESCAPE_STORED_IN_GLOBAL.

2007-04-26  Jakub Jelinek  <jakub@redhat.com>

	PR c++/31598
	* tree-inline.c (copy_body_r): Don't touch TREE_TYPE of OMP_CLAUSE.

	PR tree-optimization/30558
	* tree-eh.c (lower_eh_filter): If EH_FILTER_MUST_NOT_THROW
	clear this_state.prev_try.

2007-04-25  Anatoly Sokolov <aesok@post.ru>

	PR target/18989
 	* config/avr/avr.h (ASM_OUTPUT_ALIGN): Redefine.

2007-04-24  Andrew Pinski  <andrew_pinski@playstation.sony.com>
	    Roger Sayle  <roger@eyesopen.com>

	PR middle-end/30222
	* expmed.c (make_tree): Use the correct type, i.e. the inner
	type, when constructing the individual elements of a CONST_VECTOR.

2007-04-24  Ian Lance Taylor  <iant@google.com>

	PR tree-optimization/31605
	* tree-vrp.c (set_value_range): Check that min and max are not
	both overflow infinities.
	(set_value_range_to_value): New static function.
	(extract_range_from_binary_expr): Call set_value_range_to_value.
	(extract_range_from_expr): Likewise.
	(extract_range_from_unary_expr): Likewise.  Don't create a range
	which overflows on both sides.
	(vrp_meet): Check for a useless range.
	(vrp_visit_phi_node): If we see a constant which looks like an
	overflow infinity, turn off the TREE_OVERFLOW flag.

2007-04-24  Ian Lance Taylor  <iant@google.com>

	PR tree-optimization/31602
	* tree-ssa-loop-ch.c (copy_loop_headers): Set TREE_NO_WARNING for
	conditionals in the copied loop header.
	* tree-cfg.c (fold_cond_expr_cond): Don't issue undefined overflow
	warnings if TREE_NO_WARNING is set.
	* doc/invoke.texi (Warning Options): Clarify that
	-Wstrict-overflow does not warn about loops.

2007-04-24  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR target/31641
	* config/s390/s390.c (s390_expand_setmem): Don't ICE for constant length
	argument of 0 for memset.
	(s390_expand_movmem, s390_expand_setmem, s390_expand_cmpmem): Use
	unsigned shift instead of the signed variant.

2007-04-24  Daniel Franke  <franke.daniel@gmail.com>

	* doc/invoke.texi: Removed leading '-' from option index entries.

2007-04-22  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR middle-end/31448
	* expr.c (reduce_to_bit_field_precision): Handle
	CONST_INT rtx's.

2007-04-20  Richard Henderson  <rth@redhat.com>

	PR target/28623
	* config/alpha/alpha.c (get_unaligned_address): Remove extra_offset
	argument; update all callers.
	(get_unaligned_offset): New.
	* config/alpha/alpha.md (extendqidi2, extendhidi2): Don't use
	get_unaligned_address, just pass on the address directly.
	(unaligned_extendqidi): Use gen_lowpart instead of open-coding
	the subreg in the helper patterns.
	(unaligned_extendqidi_le): Use get_unaligned_offset.
	(unaligned_extendqidi_be, unaligned_extendhidi_le): Likewise.
	(unaligned_extendhidi_be): Likewise.
	(unaligned_extendhidi): Tidy.
	* config/alpha/alpha-protos.h: Update.

2007-04-21  Richard Guenther  <rguenther@suse.de>

	PR middle-end/31136
	* fold-const.c (fold_unary): Call fold_convert_const on the
	original tree.

2007-04-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/linux.h (CPP_SPEC): Undef before redefine.

2007-04-20  Bernd Schmidt  <bernd.schmidt@analog.com>

	* reload.c (combine_reloads): When trying to use a dying register,
	check whether it's uninitialized and don't use if so.

2007-04-20  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (bdesc_2arg): Use ORDERED rather than UNORDERED
	for __builtin_ia32_cmpordss.

	PR tree-optimization/31632
	* fold-const.c (fold_binary): Use op0 and op1 instead of arg0
	and arg1 for optimizations of comparison against min/max values.
	Fold arg0 to arg1's type for optimizations of comparison against
	min+1 and max-1 values.

2007-04-19  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/29841
	* cfgbuild.c (control_flow_insn_p): Return TRUE for unconditional
	trap instructions.
	* sched-deps.c (sched_analyze_insn): Prevent all non-jump instructions
	that may cause control flow transfer from being moved.

2007-04-18  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (ptrreg_to_str): Replace error() with
	output_operand_lossage().

2007-04-17  Anatoly Sokolov <aesok@post.ru>

	PR target/30483
	* config/avr/avr.c (ptrreg_to_str): Replace gcc_unreachable() with
	error().

2007-04-17  Jan Hubicka  <jh@suse.cz>

	PR middle-end/30700
	* dwarf2out.c (reference_to_unused): Ask cgraph for functions
	availablility; add more sanity checking; ask varpool only about
	VAR_DECL.

2007-04-17  H.J. Lu  <hongjiu.lu@intel.com>

	* Backport from mainline:
	2007-04-17  H.J. Lu  <hongjiu.lu@intel.com>

	* config/i386/sse.md (sse_vmaddv4sf3): Use register_operand
	on "0".
	(sse_vmmulv4sf3): Likewise.
	(sse2_vmaddv2df3): Likewise.
	(sse2_vmmulv2df3): Likewise.

2007-04-16  Matthias Klose  <doko@debian.org>

	* config/alpha/linux.h (CPP_SPEC): Define.
	* config/arm/linux-gas.h (SUBTARGET_CPP_SPEC): Extend.

2007-04-16  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (avr_arch_types): Rearranging  array.
	(enum avr_arch): Add.
	(avr_mcu_types): Use avr_arch enumeration constants instead of 
	numbers.
	* config/avr/avr.h (LINK_SPEC): Simplify.

2007-04-16  Jan Hubicka  <jh@suse.cz>

	PR target/27869
	* config/i386/sse.md
	(sse_vmaddv4sf3, sse_vmmulv4sf3): Remove '%' modifier.
	(sse_vmsmaxv4sf3_finite, sse_vmsminv4sf3_finite): Remove.
	(sse2_vmaddv2df3, sse2_vmmulv2df3): Remove '%' modifier.
	(sse2_vmsmaxv2df3_finite, sse2_vmsminv2df3_finite): Remove.

2007-04-16  H.J. Lu  <hongjiu.lu@intel.com>

	* Backport from mainline:
	2007-04-16  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/31582
	* config/i386/i386.c (ix86_expand_vec_set_builtin): Make a
	copy of source, pass it to ix86_expand_vector_set and return
	it as target.

2007-04-14  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR c/31520
	* c-decl.c (finish_decl): Grab the type of the decl after the call
	to store_init_value.

2007-04-14  Jakub Jelinek  <jakub@redhat.com>

	PR c++/25874
	* omp-low.c (expand_omp_parallel): If child_cfun->cfg, free dominators,
	post dominators and cleanup cfg before returning.

2007-04-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (pa_som_asm_init_sections): Ensure that cfun->machine is not
	null before emitting a .nsubspa directive.

2007-04-08  Anatoly Sokolov <aesok@post.ru>

	PR target/29932
	* config/avr/predicates.md (io_address_operand): Delete predicate.
	(low_io_address_operand): Don't use 'mode' argument.
	(higth_io_address_operand): Rename ...
	(high_io_address_operand): ... to this. Don't use 'mode' argument.
	* config/avr/avr.md (*sbix_branch_tmp, *sbix_branch_tmp_bit7): Adjust
	for above change.

2007-04-07  Anatoly Sokolov <aesok@post.ru>

	PR target/30289
	* config/avr/avr.md (*clrmemqi, *clrmemhi): Mark operand 4 as 
	earlyclobber.

2007-04-05  Anatoly Sokolov <aesok@post.ru>

	PR target/25448
	* config/avr/avr.c (avr_handle_fndecl_attribute): Use the 
	DECL_ASSEMBLER_NAME, not the DECL_NAME.

2007-04-04  Richard Henderson  <rth@redhat.com>

	PR target/31361
	* config/i386/i386.c (ix86_init_mmx_sse_builtins): Remove
	v8hi_ftype_v8hi_v2di, v4si_ftype_v4si_v2di.  Use like-types for
	the variable shift builtins.
	(ix86_expand_builtin): Properly expand the variable shift builtins.
	* config/i386/sse.md (ashr<mode>3, lshr<mode>3, ashl<mode>3): Make
	operand 2 be TImode.
	* config/i386/emmintrin.h (_mm_slli_epi16, _mm_slli_epi32,
	_mm_slli_epi64, _mm_srai_epi16, _mm_srai_epi32, _mm_srli_epi16,
	_mm_srli_epi32, _mm_srli_epi64): Turn into macros.
	(_mm_srli_si128, _mm_srli_si128): Fix disabled inline versions.
	(_mm_sll_epi16, _mm_sll_epi32, _mm_sll_epi64, _mm_sra_epi16,
	_mm_sra_epi32, _mm_srl_epi16, _mm_srl_epi32, _mm_srl_epi64): Use
	two-vector shift builtins.

2007-04-04  Chen liqin  <liqin@sunnorth.com.cn>

	* config/score/crti.asm: Change _bss_start to __bss_start.
	* config/score/score.h (CONDITIONAL_REGISTER_USAGE): Added.
	(OUTGOING_REG_PARM_STACK_SPACE) update.
	* config/score/score.opt: add options to make backend support
	score5, score5u, score7 and score7d.
	* config/score/score.md: Likewise.
	* config/score/misc.md: Likewise.
	* config/score/mac.md: Likewise.
	* doc/invoke.texi: Likewise.
	* doc/md.texi: update constraints define.

2007-04-03  Stuart Hastings  <stuart@apple.com>

	PR 31281
	* objc/objc-act.c (next_sjlj_build_catch_list): Delete volatile
	from rethrow decl.
	* cse.c (record_jump_equiv): Bail out on CCmode comparisons.

2007-04-03  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/30704
	* fold-const.c (native_encode_real): Encode real.c provided longs
	as a series of 32-bit native integers.
	(native_interpret_real): Interpret buffer as a series of 32-bit
	native integers.

2007-04-02  Eric Christopher  <echristo@apple.com>

	* doc/invoke.texi (i386 and x86-64 Options): Document -m64
	limitations on darwin.

2007-04-02  Anatoly Sokolov <aesok@post.ru>

	PR target/31137
	* config/avr/avr.c (avr_rtx_costs): Add missing 'break' statements.

2007-04-02  H.J. Lu  <hongjiu.lu@intel.com>

	* Backport from mainline:
	2007-03-28  Grigory Zagorodnev <grigory_zagorodnev@linux.intel.com>

	PR target/31380
	* config/i386/sse.md (uminv16qi3): Use UMIN instead of UMAX.

2007-03-30  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (avr_override_options): Clear
	'flag_delete_null_pointer_checks'.

2007-03-29  Michael Matz  <matz@suse.de>

	* builtins.c (expand_builtin_sync_operation,
	expand_builtin_compare_and_swap,
	expand_builtin_lock_test_and_set): Care for extending CONST_INTs
	correctly.

	* config/i386/sync.md (sync_double_compare_and_swapdi_pic,
	sync_double_compare_and_swap_ccdi_pic): Use "SD" as constraint
	for operand 3.

2007-03-28  Mike Stump  <mrs@apple.com>

	* config/darwin9.h (ASM_OUTPUT_ALIGNED_COMMON): Add.
	* config/darwin.h (MAX_OFILE_ALIGNMENT): Fix.
	* config/rs6000/darwin.h (ASM_OUTPUT_ALIGNED_COMMON): Removed #undef.

2007-03-27  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (avr_mcu_types): Move at90usb82 device to 'avr4'
	architecture.

2007-03-26  Ian Lance Taylor  <iant@google.com>

	PR tree-optimization/31345
	* tree-vrp.c (extract_range_from_binary_expr): Turn ranges like
	[+INF, +INF(OVF)] into VARYING.

2007-03-23  Martin Michlmayr  <tbm@cyrius.com>

	* doc/invoke.texi (-fforce-mem): Update documentation to reflect
	that this option will be removed in 4.3 rather than 4.2.
	* opts.c (common_handle_option): Likewise.

2007-03-21  Mike Stump  <mrs@apple.com>

	* c.opt: Fixup for Objective-C/C++.

2007-03-21  Richard Henderson  <rth@redhat.com>

	PR target/31245
	* config/i386/emmintrin.h (__m128i, __m128d): Mark may_alias.
	* config/i386/mmintrin.h (__m64): Likewise.
	* config/i386/xmmintrin.h (__m128): Likewise.

2007-03-20  Jakub Jelinek  <jakub@redhat.com>

	PR c/30762
	* c-typeck.c (convert_for_assignment): Call comptypes for
	RECORD_TYPE or UNION_TYPE.

	PR inline-asm/30505
	* reload1.c (reload): Do invalid ASM checking after
	cleanup_subreg_operands.

2007-03-19  Jeff Law  <law@redhat.com>

	* tree-cfg.c (find_taken_edge): Tighten conditions for
	optimizing computed gotos.

2007-03-16  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (attr_length_call): Partially revert change of 2007-03-09.
	(output_call): Likewise.

2007-03-16  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/29906
	* dwarf2out.c (force_type_die): Adjust comment.
	(dwarf2out_imported_module_or_decl): Handle base AT_import types.

2007-03-15  Seongbae Park <seongbae.park@gmail.com>

	PR tree-optimization/30590
	* tree-nrv.c (tree_nrv): Check for the partial update
	of the return value.

2007-03-14  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c (value_inside_range): Ignore fold warnings.

2007-03-13  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/31123
	* pa.md (vdepi_ior): Don't allow zero length deposit.  Likewise for
	two unamed patterns.

2007-03-12  Brooks Moses  <brooks.moses@codesourcery.com>

	* doc/extend.texi: Edit "gnu_inline" documentation.
	* doc/invoke.texi: Edit "-fgnu89-inline" documentation.

2007-03-12  Brooks Moses  <brooks.moses@codesourcery.com>

	* doc/extend.texi: Fix cpp.info cross-reference.
	* doc/invoke.texi: Fix cpp.info cross-reference.
	* doc/passes.texi: Fix gcc.info cross-reference.

2007-03-12  Daniel Berlin  <dberlin@dberlin.org>

	Fix PR tree-optimization/28544
	* tree-ssa-operands.c (add_virtual_operand):
	Move assert triggering on aliasing violations into
	debugging define

2007-03-12  Ian Lance Taylor  <iant@google.com>

	* c.opt (fgnu89-inline): New option.
	* c-opts.c (c_common_post_options): Warn about -fno-gnu89-inline.
	* c-common.c (c_common_attributes): Add gnu_inline attribyte.
	(handle_gnu_inline_attribute): New static function.
	* c-decl.c (start_function): Warn if we see a non-static inline
	function in C99 mode.
	* c-cppbuiltin.c (c_cpp_builtins): Define __GNUC_GNU_INLINE__.
	* doc/invoke.texi (Option Summary): Mention -fgnu89-inline.
	(C Dialect Options): Document -fgnu89-inline.
	* doc/extend.texi (Function Attributes): Document gnu_inline.
	(Inline): Mention that C99 inline will be implemented in 4.3.
	Refer to ways to get the old handling.
	* doc/cpp.texi (Common Predefined Macros): Document
	__GNUC_GNU_INLINE__ and __GNUC_STDC_INLINE__.

2007-03-12  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_elf_section_type_flags): New.
	(TARGET_SECTION_TYPE_FLAGS): New.

2007-03-12  Richard Henderson  <rth@redhat.com>

	* config/darwin.c (machopic_reloc_rw_mask): New.
	(machopic_select_section): Use decl_readonly_section.
	* config/darwin-protos.h (machopic_reloc_rw_mask): Declare.
	* config/darwin.h (TARGET_ASM_RELOC_RW_MASK): New.

2007-02-14  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	* flags.h (issue_strict_overflow_warning): Convert to a macro.

2007-03-11  Ian Lance Taylor  <iant@google.com>

	Backport -fstrict-overflow/-Wstrict-overflow from mainline:
	2007-03-11  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c (vrp_int_const_binop): Handle PLUS_EXPR and
	the *_DIV_EXPR codes correctly with overflow infinities.

	2007-03-09  Ian Lance Taylor  <iant@google.com>

	* opts.c (common_handle_option): Treat -Wstrict-overflow (with no
	argument) like -Wstrict-overflow=2.
	* doc/invoke.texi (Warning Options): Update documentation.

	2007-03-08  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c: Include "toplev.h" and "intl.h".
	(usable_range_p): New static function.
	(compare_values_warnv): Don't test TYPE_OVERFLOW_UNDEFINED for
	overflowed values, juts set *strict_overflow_p.
	(compare_values): Only return -2 if one of the operands is not a
	constant.
	(compare_ranges): Call usable_range_p.
	(compare_range_with_value): Likewise.
	(vrp_evaluate_conditional_warnv): Rename from
	vrp_evaluate_conditional.  Make static.  Change all callers.
	(vrp_evaluate_conditional): New function.
	(simplify_div_or_mod_using_ranges): Issue warning about reliance
	on signed overflow.
	(simplify_abs_using_ranges): Likewise.
	(simplify_stmt_for_jump_threading): Add within_stmt parameter.
	* tree-ssa-dom.c (simplify_stmt_for_jump_threading): Add
	within_stmt parameter.
	* tree-ssa-propagate.c (fold_predicate_in): Update call to
	vrp_evaluate_conditional.
	* tree-ssa-threadedge.c
	(record_temporary_equivalences_from_stmts_at_dest): Change
	simplify parameter to take a second tree parameter.
	(simplify_control_stmt_condition): Likewise.
	(thread_across_edge): Likewise.
	* tree-flow.h (vrp_evaluate_conditional): Update declaration.
	(thread_across_edge): Likewise.
	* Makefile.in (tree-vrp.o): Depend upon toplev.h and intl.h.

	2007-03-05  Ian Lance Taylor  <iant@google.com>

	* tree-vrp.c (extract_range_from_assert): Don't try to handle a
	half-range if the other side is an overflow infinity.

	2007-03-02  Ian Lance Taylor  <iant@google.com>

	Used signed infinities in VRP.
	* tree-vrp.c (uses_overflow_infinity): New static function.
	(supports_overflow_infinity): New static function.
	(make_overflow_infinity): New static function.
	(negative_overflow_infinity): New static function.
	(positive_overflow_infinity): New static function.
	(is_negative_overflow_infinity): New static function.
	(is_positive_overflow_infinity): New static function.
	(is_overflow_infinity): New static function.
	(overflow_infinity_range_p): New static function.
	(compare_values_warnv): New function split out of compare_values.
	(compare_value): Call it.
	(set_value_range_to_nonnegative): Add overflow_infinity
	parameter.  Change caller.
	(vrp_expr_computes_nonnegative): Add strict_overflow_p parameter.
	Change callers.
	(vrp_expr_computes_nonzero): Likewise.
	(compare_ranges, compare_range_with_value): Likewise.
	(compare_name_with_value, compare_names): Likewise.
	(vrp_evaluate_conditional): Likewise.
	(set_value_range): Handle infinity
	(vrp_operand_equal_p, operand_less_p): Likewise.
	(extract_range_from_assert): Likewise.
	(vrp_int_const_binop): Likewise.
	(extract_range_from_binary_expr): Likewise.
	(extract_range_from_unary_expr): Likewise.
	(extract_range_from_comparison): Likewise.
	(extract_range_from_expr): Likewise.
	(dump_value_range): Likewise.
	(vrp_visit_cond_stmt, vrp_visit_phi_node): Likewise.
	(test_for_singularity): Likewise.
	(vrp_int_const_binop): Remove inline qualifier.
	(adjust_range_with_scev): Add comment.
	* tree-flow.h (vrp_evaluate_conditional): Update declaration.

	2007-02-13  Ian Lance Taylor  <iant@google.com>

	* common.opt: Add Wstrict-overflow and Wstrict-overflow=.
	* flags.h (warn_strict_overflow): Declare.
	(enum warn_strict_overflow_code): Define.
	(issue_strict_overflow_warning): New static inline function.
	* opts.c (warn_strict_overflow): New variable.
	(common_handle_option): Handle OPT_Wstrict_overflow and
	OPT_Wstrict_overflow_.
	* c-opts.c (c_common_handle_option): Set warn_strict_overflow for
	OPT_Wall.
	* fold-const.c: Include intl.h.
	(fold_deferring_overflow_warnings): New static variable.
	(fold_deferred_overflow_warning): New static variable.
	(fold_deferred_overflow_code): New static variable.
	(fold_defer_overflow_warnings): New function.
	(fold_undefer_overflow_warnings): New function.
	(fold_undefer_and_ignore_overflow_warnings): New function.
	(fold_deferring_overflow_warnings_p): New function.
	(fold_overflow_warning): New static function.
	(make_range): Add strict_overflow_p parameter.  Change all
	callers.
	(extract_muldiv, extract_muldiv_1): Likewise.
	(fold_unary) [ABS_EXPR]: Check ABS_EXPR before calling
	tree_expr_nonnegative_p.
	(fold_negate_expr): Call fold_overflow_warning.
	(fold_range_test): Likewise.
	(fold_comparison): Likewise.
	(fold_binary): Likewise.  Call tree_expr_nonnegative_warnv_p
	instead of tree_expr_nonnegative_p.
	(tree_expr_nonnegative_warnv_p): Rename from
	tree_expr_nonnegative_p, add strict_overflow_p parameter.
	(tree_expr_nonnegative_p): New function.
	(tree_expr_nonzero_warnv_p): Rename from tree_expr_nonzero_p, add
	strict_overflow_p parameter.
	(tree_expr_nonzero_p): New function.
	* passes.c (verify_interpass_invariants): New static function.
	(execute_one_pass): Call it.
	* tree-ssa-loop-niter.c (expand_simple_operations): Ignore fold
	warnings.
	(number_of_iterations_exit, loop_niter_by_eval): Likewise.
	(estimate_numbers_of_iterations): Likewise.
	(scev_probably_wraps_p): Likewise.
	* tree-ssa-ccp.c: Include "toplev.h".
	(evaluate_stmt): Defer fold overflow warnings until we know we are
	going to optimize.
	(struct fold_stmt_r_data): Add stmt field.
	(fold_stmt_r): Defer fold overflow warnings until we know we
	optimized.
	(fold_stmt): Initialize stmt field of fold_stmt_r_data.
	(fold_stmt_inplace): Likewise.
	* tree-cfgcleanup.c: Include "toplev.h" rather than "errors.h".
	(cleanup_control_expr_graph): Defer fold overflow warnings until
	we know we are going to optimize.
	* tree-cfg.c (fold_cond_expr_cond): Likewise.
	* tree-ssa-threadedge.c (simplify_control_stmt_condition):
	Likewise.
	* tree-vrp.c (vrp_expr_computes_nonnegative): Call
	tree_expr_nonnegative_warnv_p instead of tree_expr_nonnegative_p.
	* tree-ssa-loop-manip.c (create_iv): Likewise.
	* c-typeck.c (build_conditional_expr): Likewise.
	(build_binary_op): Likewise.
	* tree-vrp.c (vrp_expr_computes_nonzero): Call
	tree_expr_nonzero_warnv_p instead of tree_expr_nonzero_p.
	(extract_range_from_unary_expr): Likewise.
	* simplify-rtx.c (simplify_const_relational_operation): Warn when
	assuming that signed overflow does not occur.
	* c-common.c (pointer_int_sum): Ignore fold overflow warnings.
	* tree.h (tree_expr_nonnegative_warnv_p): Declare.
	(fold_defer_overflow_warnings): Declare.
	(fold_undefer_overflow_warnings): Declare.
	(fold_undefer_and_ignore_overflow_warnings): Declare.
	(fold_deferring_overflow_warnings_p): Declare.
	(tree_expr_nonzero_warnv_p): Declare.
	* doc/invoke.texi (Option Summary): Add -Wstrict-overflow to list
	of warning options.
	(Warning Options): Document -Wstrict-overflow.
	* Makefile.in (tree-ssa-threadedge.o): Depend on toplev.h.
	(tree-ssa-ccp.o): Likewise.
	(tree-cfgcleanup.o): Change errors.h dependency to toplev.h.
	(fold-const.o): Depend on intl.h.

	2007-01-27  Ian Lance Taylor  <iant@google.com>

	* common.opt: Add fstrict-overflow.
	* opts.c (decode_options): Set flag_strict_overflow if -O2.
	* flags.h (TYPE_OVERFLOW_WRAPS): Define.
	(TYPE_OVERFLOW_UNDEFINED): Define.
	(TYPE_OVERFLOW_TRAPS): Define.  This replaces TYPE_TRAP_SIGNED.
	Replace all uses.
	* tree.h (TYPE_TRAP_SIGNED): Don't define.
	* fold-const.c (negate_expr_p): Use TYPE_OVERFLOW_UNDEFINED.
	(fold_negate_expr): Likewise.
	(make_range): Likewise.
	(extract_muldiv_1): Likewise.
	(fold_comparison): Likewise.
	(fold_binary): Likewise.
	(tree_expr_nonnegative_p): Likewise.
	(tree_expr_nonzero_p): Likewise.
	* tree-vrp.c (compare_values): Likewise.
	(extract_range_from_binary_expr): Likewise.
	(extract_range_from_unary_expr): Likewise.
	* tree-ssa-loop-niter.c (infer_loop_bounds_from_undefined):
	Likewise.
	(nowrap_type_p): Likewise.
	* tree-scalar-evolution.c (simple_iv): Likewise.
	* fold-const.c (negate_expr_p): Use TYPE_OVERFLOW_WRAPS.
	(build_range_check): Likewise.
	(extract_muldiv_1): Likewise.
	(fold_comparison): Likewise.
	* tree-vrp.c (vrp_int_const_binop): Likewise.
	(extract_range_from_unary_expr): Likewise.
	* convert.c (convert_to_integer): Likewise.
	* fold-const.c (fold_negate_expr): Use TYPE_OVERFLOW_TRAPS.
	(fold_comparison): Likewise.
	(fold_binary): Likewise.
	* optabs.c (optab_for_tree_code): Likewise.
	* tree-vectorizer.c (vect_is_simple_reduction): Likewise.
	* simplify-rtx.c (simplify_const_relational_operation): Check
	flag_strict_overflow and flag_trapv.
	(simplify_const_relational_operation): Likewise.
	* doc/invoke.texi (Option Summary): Mention -fstrict-overflow.
	(Optimize Options): Add -fstrict-overflow to -O2 list.  Document
	-fstrict-overflow.

	2007-01-17  Ian Lance Taylor  <iant@google.com>

	* vec.h (VEC_reserve_exact): Define.
	(vec_gc_p_reserve_exact): Declare.
	(vec_gc_o_reserve_exact): Declare.
	(vec_heap_p_reserve_exact): Declare.
	(vec_heap_o_reserve_exact): Declare.
	(VEC_OP (T,A,reserve_exact)): New static inline function, three
	versions.
	(VEC_OP (T,A,reserve)) [all versions]: Remove handling of
	negative parameter.
	(VEC_OP (T,A,alloc)) [all versions]: Call ...reserve_exact.
	(VEC_OP (T,A,copy)) [all versions]: Likewise.
	(VEC_OP (T,a,safe_grow)) [all versions]: Likewise.
	* vec.c (calculate_allocation): Add exact parameter.  Change all
	callers.
	(vec_gc_o_reserve_1): New static function, from vec_gc_o_reserve.
	(vec_gc_p_reserve, vec_gc_o_reserve): Call vec_gc_o_reserve_1.
	(vec_gc_p_reserve_exact, vec_gc_o_reserve_exact): New functions.
	(vec_heap_o_reserve_1): New static function, from vec_heap_o_reserve.
	(vec_heap_p_reserve, vec_heap_o_reserve): Call vec_heap_o_reserve_1.
	(vec_heap_p_reserve_exact): New function.
	(vec_heap_o_reserve_exact): New function.

2007-03-11  Roger Sayle  <roger@eyesopen.com>
	    Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR middle-end/30433
	* fold-const.c (fold_relational_const): Add back compile-time
	evaluation of complex constant equality/inequality comparisons.

2007-03-11  Ira Rosen  <irar@il.ibm.com>

	PR tree-optimization/29925
	* tree-data-ref.c (analyze_offset): Add a return value (bool) to
	indicate success/failure of the analysis. Add negation to subtrahend
	in case of subtraction. Fail if both operands contain constants.
	(create_data_ref): Fail if analyze_offset fails.

2007-03-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/30924
	* tree.c (walk_type_fields): Recurse into the element type of
	ARRAY_TYPEs if there is a pointer set.

2007-03-09  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (attr_length_call): Revise condition for long pc-relative branch.
	(output_call): Use "LONG_PIC_SDIFF" instruction sequence for long local
	calls on the SOM target.  Don't use "LONG_PIC_PCREL" call sequence on
	SOM target.

2007-03-09  Richard Henderson  <rth@redhat.com>

	PR target/26090
	* target.h (targetm.asm.out.reloc_rw_mask): New.
	* target-def.h (TARGET_ASM_RELOC_RW_MASK): New.
	(TARGET_ASM_OUT): Use it.
	* targhooks.c, targhooks.h (default_reloc_rw_mask): New.
	* varasm.c (categorize_decl_for_section): Remove shlib argument;
	use the new reloc_rw_mask target hook instead.
	(default_section_type_flags_1): Merge into...
	(default_section_type_flags): ... here.
	(decl_readonly_section_1): Merge into...
	(decl_readonly_section): ... here.
	(default_elf_select_section_1): Merge into...
	(default_elf_select_section): ... here.
	(default_unique_section_1): Merge into...
	(default_unique_section): ... here.
	(compute_reloc_for_rtx_1, compute_reloc_for_rtx): New.
	(default_select_rtx_section): Use it.
	(default_elf_select_rtx_section): Likewise.
	* output.h: Update to match.
	* doc/tm.texi (TARGET_ASM_RELOC_RW_MASK): New.
	* config/alpha/alpha.c (alpha_elf_reloc_rw_mask): New.
	(TARGET_ASM_RELOC_RW_MASK): New.
	* config/i386/i386.c (x86_64_elf_select_section): Adjust call
	to categorize_decl_for_section.
	(x86_64_elf_unique_section): Likewise.
	* config/ia64/hpux.h (TARGET_ASM_SELECT_SECTION,
	TARGET_ASM_UNIQUE_SECTION, TARGET_ASM_SELECT_RTX_SECTION): Remove.
	(TARGET_ASM_RELOC_RW_MASK): New.
	* config/ia64/ia64.c (ia64_rwreloc_select_section,
	ia64_rwreloc_unique_section, ia64_rwreloc_select_rtx_section): Remove.
	(ia64_hpux_reloc_rw_mask, ia64_reloc_rw_mask): New.
	(TARGET_RWRELOC): Remove.
	(ia64_section_type_flags): Adjust call to default_section_type_flags.
	* config/ia64/sysv4.h (TARGET_ASM_RELOC_RW_MASK): New.
	* config/rs6000/rs6000.c (rs6000_elf_section_type_flags): Remove.
	(rs6000_elf_select_section, rs6000_elf_unique_section): Remove.
	(rs6000_elf_reloc_rw_mask, rs6000_xcoff_reloc_rw_mask): New.
	(rs6000_xcoff_select_section): Use decl_readonly_section.
	(rs6000_xcoff_section_type_flags): Use default_section_type_flags.
	* config/rs6000/sysv4.h (TARGET_ASM_RELOC_RW_MASK): New.
	(TARGET_ASM_SELECT_SECTION, TARGET_ASM_UNIQUE_SECTION): Remove.
	(TARGET_SECTION_TYPE_FLAGS): Remove.
	* config/rs6000/xcoff.h (TARGET_ASM_RELOC_RW_MASK): New.

2007-03-08  Geoffrey Keating  <geoffk@apple.com>

	PR 31013
	* gccspec.c (lang_specific_driver): Do nothing when NEXT_OBJC_RUNTIME
	is declared.
	* config/darwin.h (REAL_LIBGCC_SPEC): When -fgnu-runtime is
	passed, use shared libgcc.

2007-03-09  Alexandre Oliva  <aoliva@redhat.com>

	PR rtl-optimization/30643
	* cse.c (cse_insn): Recompute dest_hash after insert_regs for
	dest_addr_elt.

2007-03-09  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/30045
	* tree-vrp.c (nonnull_arg_p): Treat the static decl as always
	non null.

2007-03-09  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR middle-end/30729
	* stmt.c (warn_if_unused_value): VA_ARG_EXPR has side
	effects unknown to this function, return early.

2007-03-09  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR tree-opt/28624
	* tree-ssa-dom.c (eliminate_degenerate_phis): Use a temporary
	bitmap for EXECUTE_IF_SET_IN_BITMAP.

2006-03-09  Mark Shinwell  <shinwell@codesourcery.com>
	    Andrew MacLeod  <amacleod@redhat.com>
	PR tree-optimization/29877
	* tree-outof-ssa.c (check_replaceable): Don't allow TER to replace
	an expression if the RHS is a register variable.

2007-03-08  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	PR C/31072
	* c-decl.c (merge_decls): Don't call make_var_volatile.
	* varasm.c (make_var_volatile): Remove.
	* output.h (make_var_volatile): Remove.

2007-03-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.def (lceil, lceilf, lceill, lfloor, lfloorf, lfloorl,
	llceil, llceilf, llceill, llfloor, llfloorf, llfloorl): Mark with
	ATTR_CONST_NOTHROW_LIST.

	* fold-const.c (tree_expr_nonnegative_p): Handle FIX_TRUNC_EXPR.

2007-03-08 Andrew Pinski <andrew_pinski@playstation.sony.com>

	PR target/30406
	* config/rs6000/rs6000.c (rs6000_function_value): Look at bit size
	instead of precision.

2007-03-08  Volker Reichelt  <v.reichelt@netcologne.de>

	PR c++/30852
	* c-common.c (fold_offsetof_1): Handle COMPOUND_EXPR.

2007-03-07  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	* c.opt (Waddress): New.
	* common.opt (Walways-true): Delete.
	(Wstring-literal-comparison): Delete.
	* doc/invoke.texi (Warning Options): Delete -Walways-true and
	-Wstring-literal-comparison. Add -Waddress.
	(Waddress): New.
	(Walways-true): Delete.
	(Wstring-literal-comparison): Delete.
	* doc/extend.texi (#pragma GCC diagnostic): Use -Wformat
	consistently instead of -Walways-true in example.
	* c-opts.c (c_common_handle_option): -Waddress is enabled by -Wall.
	* c-typeck.c (parser_build_binary_op): Replace
	-Wstring-literal-comparison and -Walways-true with -Waddress.
	(build_binary_op): Likewise.
	* c-common.c (c_common_truthvalue_conversion): Likewise.

2007-03-07  Richard Henderson  <rth@redhat.com>

	PR target/30848
	* reg-stack.c (emit_swap_insn): If a malformed asm was seen,
	silently fix up the stack in the case of a missing register.

2007-03-06  David Daney  <ddaney@avtrex.com>

	* doc/install.texi (mips-*-*): Change recommended binutils
	version.

2007-03-06  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	* doc/invoke.texi (Warning Options): Replace -Werror- with
	-Werror=.
	* opts.c (common_handle_option): Likewise.

2007-03-06  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.c (avr_mcu_types): Add support for ATmega325P,
	ATmega3250P, ATmega329P, ATmega3290P, AT90USB82 and AT90USB162
	devices.
	* config/avr/avr.h (LINK_SPEC, CRT_BINUTILS_SPECS): (Ditto.).
	* config/avr/t-avr (MULTILIB_MATCHES): (Ditto.).

2007-03-06  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/30744
	* fold-const.c (fold_binary) <EQ_EXPR>: Enforce type consistency
	when transforming ~X op C to X op' ~C.

2007-03-05  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.md: In unamed move patterns, disparge copies between general
	and floating point registers using '?' modifier.  Don't include 'f'
	constraint for register preferences in DImode, SImode, HImode and
	QImode patterns.  Likewise for 'r' in DFmode and SFmode patterns.
	Remove constraints for copies between general and floating registers
	in soft-float DFmode pattern.
	(movdf): Fail if operand1 is a CONST_DOUBLE and operand0 is a hard
	floating register.
	(movsf): Likewise.

2007-03-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* convert.c (convert_to_integer): Fix nearbyint/rint -> *lrint
	conversion.

2007-03-05  Steve Ellcey  <sje@cup.hp.com>

	Backported from mainline
	PR debug/29614
	* cgraph.h (cgraph_varpool_last_needed_node): Make global.
	* cgraph.c (cgraph_varpool_last_needed_node): Ditto.
	* cgraphunit.c (cgraph_varpool_assemble_pending_decls):
	Set cgraph_varpool_last_needed_node to NULL.

2007/03/05  David Taylor  <dtaylor@emc.com>

	PR 31050
	* gcc.c: Correct copyright date in --version output.

2007-03-05  Brooks Moses  <brooks.moses@codesourcery.com>

	* c.opt: Remove -ffixed-form, -ffixed-line-length-none, and
	-ffixed-line-length-* options.

2007-03-05  David Edelsohn  <edelsohn@gnu.ogr>

	* config/rs6000/t-ppccomm: Always build libgcc2 for GNU/Linux
	with -mlong-double-128, except SPE.

	* config/rs6000/darwin-ldouble.c: Only build new functions for
	__LONG_DOUBLE_128__.

	Backport from mainline:
	2007-01-16  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/darwin-ldouble.c: Build file for SOFT_FLOAT.
	(strong_alias): Define.
	(__gcc_qmul): Provide non-FMA for soft-float.
	(__gcc_qdiv): Same.
	(__gcc_qneg): New.
	(__gcc_qeq): New.
	(__gcc_qle): New.
	(__gcc_qge): New.
	(__gcc_qunord): New.
	(__gcc_stoq): New.
	(__gcc_dtoq): New.
	(__gcc_qtos): New.
	(__gcc_qtod): New.
	(__gcc_qtoi): New.
	(__gcc_qtou): New.
	(__gcc_itoq): New.
	(__gcc_utoq): New.
	(fmsub): New.
	* config/rs6000/rs6000.c (rs6000_init_libfuncs): Initialize
	soft-float functions.
	* config/rs6000/libgcc-ppc-glibc.ver: Version soft-float symbols.
	* config/rs6000/sysv4.h (SUBTARGET_OVERRIDE_OPTIONS): Do not warn
	about long double soft float.

2007-03-05  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2007-02-28  Richard Guenther  <rguenther@suse.de>

	PR middle-end/30364
	* fold-const.c (fold_binary): Do not associate expressions
	with more than one variable for integer types that do not wrap.

2007-03-04  Eric Botcazou  <ebotcazou@adacore.com>

	PR ada/26797
	* doc/invoke.texi (-O2): Document that Tree-VRP is not turned on
	for the Ada compiler.

2007-03-02  Zdenek Dvorak <dvorakz@suse.cz>

	PR tree-optimization/29902
	* tree-ssa-loop-manip.c (can_unroll_loop_p): Return false if
	any involved ssa name appears in abnormal phi node.

2007-03-02  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-sra.c (sra_walk_fns) <ldst>: Document new restriction.
	(sra_walk_modify_expr) <rhs_elt>: Treat the reference as a use
	if the lhs has side-effects.
	<lhs_elt>: Treat the reference as a use if the rhs has side-effects.

2007-03-02  Paul Brook  <paul@codesourcery.com>

	* config/arm/arm.c (arm_legitimate_index_p): Limit iWMMXt addressing
	modes to LDRD for DImode.
	(output_move_double): Fixup out of range ldrd/strd.
	(vfp_secondary_reload_class): Rename...
	(coproc_secondary_reload_class): ... to this.  Add wb argument.
	* config/arm/arm.h (SECONDARY_OUTPUT_RELOAD_CLASS): Use
	coproc_secondary_reload_class for CLASS_IWMMXT.
	(SECONDARY_INPUT_RELOAD_CLASS): Ditto.
	* arm-protos.h (coproc_secondary_reload_class): Update prototype.

2007-03-02  Eric Botcazou  <ebotcazou@adacore.com>

	* config/alpha/alpha.c (alpha_gp_save_rtx): Insert the insns at the
	entry by means of emit_insn_at_entry.

2007-03-01  Manuel Lopez-Ibanez  <manu@gcc.gnu.org>

	* doc/invoke.texi (Wextra): Delete outdated paragraph.

2007-02-27  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa/predicates.md (move_src_operand): Allow zero for mode.
	* pa/pa.md: Fix constraints for zero CONST_DOUBLE in 64-bit DFmode
	move pattern.

2007-02-27  Mike Stump  <mrs@apple.com>

	* config/darwin-crt3.c: Avoid compilation when compiling for a
	kext multilib.

2007-02-27  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (TEXI_GCCINSTALL_FILES): Add gcc-common.texi.

2007-02-26  Brooks Moses  <brooks.moses@codesourcery.com>

	* Makefile.in (TEXI_GCCINSTALL_FILES): Add gcc-vers.texi dependency.

2007-02-26  Brooks Moses  <brooks.moses@codesourcery.com>

	* doc/include/gcc-common.texi (versionsubtitle): New macro.
	* doc/cpp.texi: Standardize title page.
	* doc/cppinternals.texi: Likewise.
	* doc/gcc.texi: Standardize title page, remove version number
	from copyright page.
	* doc/gccint.texi: Likewise.
	* doc/install.texi: Standardize title page, add table of
	contents.

2007-02-24  Mike Stump  <mrs@apple.com>

	* config/i386/i386.c (output_pic_addr_const): Stubify optimized
	symbols.

2007-02-24  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.md (muldi3): Force subregs to registers in 64-bit expander.

2007-02-23  Mike Stump  <mrs@apple.com>

	* tlink.c (scan_linker_output): Parse linker messages from
	darwin9's linker better.

2007-02-21 Ira Rosen  <irar@il.ibm.com>

	* tree-ssa-alias.c: Include pointer-set.h
	* Makefile.in (tree-ssa-alias.o): Depend on pointer-set.h.

2007-02-21  Jakub Jelinek  <jakub@redhat.com>

	Backported from mainline
	2006-12-20  Andrew Pinski  <pinskia@gmail.com>
	PR middle-end/30143
	* omp-low.c (init_tmp_var): New function.
	(save_tmp_var): New function.
	(lower_omp_1): Use them for VAR_DECL.

2007-02-20  Alan Modra  <amodra@bigpond.net.au>

	PR target/29943
	* varasm.c (use_blocks_for_decl_p): Return false for decls with
	alias attribute.

2007-02-19  Eric Botcazou  <ebotcazou@adacore.com>

	* gimplify.c (gimplify_init_ctor_preeval_1): Detect potential overlap
	due to calls to functions taking pointers as parameters.

2007-02-19  Richard Henderson  <rth@redhat.com>

	PR debug/29558
	* var-tracking.c (track_expr_p): Disallow AGGREGATE_TYPE_P
	in memory.

2007-02-18  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-eh.c (tree_could_trap_p): Handle VIEW_CONVERT_EXPR.

2007-02-18  Eric Botcazou  <ebotcazou@adacore.com>

	* calls.c (mem_overlaps_already_clobbered_arg_p): Return true
	for arg pointer based indexed addressing.

2007-02-18 Ira Rosen  <irar@il.ibm.com>

	* tree-ssa-alias.c (may_aliases_intersect): New function.
	* tree-data-ref.c (ptr_ptr_may_alias_p): Call may_aliases_intersect
	for different tags.
	* tree-flow.h (may_aliases_intersect): Add function declaration.

2007-02-17  Alexandre Oliva  <aoliva@redhat.com>

	PR tree-optimization/30823
	* tree-sra.c (sra_build_assignment): Drop type-checking assert.

2007-02-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR other/27843
	* Makefile.in (SYSTEM_HEADER_DIR): Use single quotes to avoid
	nested double- and backquotes.

2007-02-15  Alexandre Oliva  <aoliva@redhat.com>

	* tree-sra.c (instantiate_missing_elements): Canonicalize
	bit-field types.
	(sra_build_assignment): New.
	(generate_copy_inout, generate_element_copy,
	generate_element_zero, generate_one_element_init): Use it.

2007-02-15  Kaz Kojima  <kkojima@gcc.gnu.org>

	PR rtl-optimization/29599
	Backport from mainline.
	* reload1.c (eliminate_regs_in_insn): Take the destination
	mode into account when computing the offset.

2007-02-13  Joseph S. Myers  <joseph@codesourcery.com>

	* doc/invoke.texi, doc/standards.texi: Refer to
	gcc-4.2/c99status.html.

2007-02-10  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/30634
	* pa.md (movdf): For 64-bit target, fail if operand 1 is a non-zero
	CONST_DOUBLE and operand 0 is a hard register.
	(movdi): For 64-bit target, remove code to force CONST_DOUBLE to
	memory.  Fail if operand 1 is a non-zero CONST_INT and operand 0
	is a hard floating-point register.

2007-02-06  Mark Mitchell  <mark@codesourcery.com>

	PR target/29487
	* tree.h (DECL_REPLACEABLE_P): New macro.
	* except.c (set_nothrow_function_flags): Likewise.

2007-02-07  Jakub Jelinek  <jakub@redhat.com>

	PR c++/30703
	* gimplify.c (gimplify_scan_omp_clauses): Remove special casing
	of INDIRECT_REF <RESULT_DECL>.

2007-02-06  Rask Ingemann Lamberisen  <rask@sygehus.dk>

	PR 30370
	* config/rs6000/t-ppccomm: Correct Makefile typo.

2007-02-06  Roger Sayle  <roger@eyesopen.com>

	PR libgomp/28296
	Backport from mainline.
	* config/darwin.h (CPP_SPEC): Handle -pthread, transforming
	it into -D_REENTRANT.

2007-02-05  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/30189
	* dwarf2out.c (modified_type_die): Follow DECL_ORIGINAL_TYPE
	even if cv-qualification is the same.

2007-02-05  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/darwin-tramp.asm (__trampoline_setup): Call
	__enable_execute_stack on completion.

2007-02-05  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.c (constantpool_mem_p): Skip over SUBREGs.

2007-02-02  Maxim Kuvyrkov  <mkuvyrkov@ispras.ru>

	PR target/29682
	* config/ia64/ia64.c (ia64_speculate_insn): Restrict to memory loads to
	general or fp registers.  Add comments.
	* config/ia64/ia64.md (reg_pred_prefix): Add comment.

2007-02-04  Richard Guenther  <rguenther@suse.de>

	Backport from mainline:
	2007-01-30  Richard Guenther  <rguenther@suse.de>

	PR middle-end/27657
	* dwarf2out.c (reference_to_unused): Query varpool if the
	variable was output.

2007-02-02  Mike Stump  <mrs@apple.com>

	* config.gcc (*-*-darwin*): Backport darwin9.h bits.
	* config/darwin9.h: Add.
	* config/rs6000/rs6000.c (DARWIN_GENERATE_ISLANDS): Add.
	(output_call): Use DARWIN_GENERATE_ISLANDS to decide when to
	generate a branch island.

2007-02-02  Hui-May Chang  <hm.chang@apple.com>

	Revert for x86 darwin:
	2005-06-19  Uros Bizjak  <uros@kss-loka.si>

	* config/i386/i386.c (ix86_function_arg_regno_p): Put back the
	code before the following patch under TARGET_MACHO.
	(ix86_function_value_regno_p): Likewise.

2007-02-02  Simon Martin  <simartin@users.sourceforge.net>

	PR c++/28266
	* gimplify.c (gimplify_target_expr): Make sure that the TARGET_EXPR is
	expanded only once even if an error occurs.

2007-02-02  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/30473
	* builtins.c (fold_builtin_sprintf): Do not attempt to optimize
	sprintf (str, "%s").  Do not optimize sprintf (str, "nopercent", p++).

2007-02-01  Guy Martin  <gmsoft@gentoo.org>

	* pa.md (tp_load): Correct mfctl instruction syntax.

2007-02-01  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (rs6000_stack_info): Correct
	altivec_padding_size calculation on AIX.  Improve comment, add
	assert to verify that it's right.

2007-01-31  Anatoly Sokolov <aesok@post.ru>

	PR target/19087
	* config/avr/avr.c (DWARF2_ADDR_SIZE): Define.

2007-01-30  Richard Guenther  <rguenther@suse.de>

	PR middle-end/30313
	* passes.c (execute_one_pass): Reset in_gimple_form to not
	confuse non-unit-at-a-time mode.

2007-01-27  Anatoly Sokolov <aesok@post.ru>

	* config/avr/avr.h (TARGET_CPU_CPP_BUILTINS): Define __AVR_HAVE_MUL__.

2007-01-29  Mike Stump  <mrs@apple.com>

	* doc/gccint.texi (Top): Rename Loop Representation to Loop
	Analysis and Representation to resolve case insensitive conflict.
	* doc/loop.texi (Loop Analysis and Representation): Likewise.

2007-01-29  Josh Conner  <jconner@apple.com>

	PR middle-end/29683
	* calls.c (compute_argument_addresses): Set stack and stack_slot
	for partial args, too.
	(store_one_arg): Use locate.size.constant for the size when
	generating a save_area.

2007-01-28  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/sourcebuild.texi: Add comma for clarity.
	* doc/extend.texi: Fix some typos.
	* doc/passes.texi: Likewise.
	* doc/cppinternals.texi: Likewise.
	* doc/c-tree.texi: Likewise.
	* doc/tree-ssa.texi: Likewise.
	* doc/install.texi: Likewise.

2007-01-26  Zdenek Dvorak <dvorakz@suse.cz>

	PR tree-optimization/29516
	* tree-ssa-address.c (tree_mem_ref_addr, add_to_parts,
	most_expensive_mult_to_index, addr_to_parts,
	create_mem_ref, maybe_fold_tmr): Make the type of
	fields of TARGET_MEM_REF sizetype.
	(move_fixed_address_to_symbol, move_pointer_to_base,
	aff_combination_remove_elt): New functions.
	* tree.def (TARGET_MEM_REF): Add comment on types of
	the operands.
	* gcc.dg/tree-ssa/loop-20.c: New test.

2007-01-25  Geoffrey Keating  <geoffk@apple.com>

	PR 25127
	* config/rs6000/rs6000.c (first_altivec_reg_to_save): On Darwin,
	save Altivec registers in an eh_return function.
	(compute_vrsave_mask): Likewise.
	(rs6000_stack_info): Correct AIX/Darwin stack alignment computation
	for saving Altivec registers.
	(rs6000_emit_prologue): Don't allocate stack twice in
	eh_return function.  Correct expected value of altivec_save_offset
	when using save_world.  Describe save of R0 to stack when using
	save_world.  Describe stack pointer adjustment when using
	save_world.  Remove duplicated eh_return parameter register saving.
	Update sp_offset variable after save_world.
	* config/rs6000/t-darwin (LIB2FUNCS_STATIC_EXTRA): Remove
	darwin-world.asm.
	(LIB2FUNCS_EXTRA): Add darwin-world.asm.
	* config/rs6000/darwin.h (SUBTARGET_OVERRIDE_OPTIONS): -m64
	implies Altivec.

2007-01-24  Geoffrey Keating  <geoffk@apple.com>

	* unwind-dw2.c (execute_stack_op): Handle DW_OP_swap.

2007-01-24  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/27416
	* gimplify.c (omp_check_private): New function.
	(gimplify_scan_omp_clauses): Use it for
	firstprivate/lastprivate/reduction.

	PR middle-end/30494
	* gimplify.c (omp_add_variable): Don't call omp_notice_variable
	on TYPE_SIZE_UNIT for GOVD_LOCAL VLAs.

	PR middle-end/30421
	* omp-low.c (lower_omp_for_lastprivate): Add dlist argument.
	If lower_lastprivate_clauses emits some statements, append them
	to dlist rather than body_p and to body_p append an initializer.
	(lower_omp_for): Adjust caller.

2007-01-21  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR rtl-optimization/29329
	* combine.c (replaced_rhs_insn): Rename to i2mod.
	(replaced_rhs_value): Rename to i2mod_new_rhs.
	(i2mod_old_rhs): New global variable.
	(combine_instructions): Adjust for above change.  Save a copy of
	the old RHS into i2mod_old_rhs when the contents of a REG_EQUAL
	note are substituted in the second instruction.
	(distribute_notes) <REG_DEAD>: Adjust for above change.  Do not
	ditch the note if it pertains to the second eliminated register
	and this register is mentioned in i2mod_old_rhs.

	Revert:
	2006-09-12  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* combine.c (distribute_notes) <REG_DEAD>: Do not consider SETs past
	the insn to which the note was originally attached.

2007-01-20  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (output_move_double): Change array size of xoperands to 4.

2007-01-17  Eric Christopher  <echristo@apple.com>

	Backport from mainline:
	2006-12-18  Roger Sayle  <roger@eyesopen.com>
	            Eric Christopher  <echristo@apple.com>

	PR target/29302
	* real.c (real_maxval): Correctly handle IBM extended double format.

2007-01-17  Tom Tromey  <tromey@redhat.com>

	* doc/sourcebuild.texi (libgcj Tests): Use sourceware.org.
	* doc/install.texi (Testing): Use sourceware.org.
	(Binaries): Likewise.
	(Specific): Likewise.
	* doc/contrib.texi (Contributors): Use sourceware.org.

2007-01-15  Joseph S. Myers  <joseph@codesourcery.com>

	* config/soft-fp/op-common.h, config/soft-fp/op-4.h: Update from
	glibc CVS.

2007-01-11  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa-linux.h (ASM_OUTPUT_INTERNAL_LABEL): Undefine.
	* pa.h (ASM_OUTPUT_LABEL): Output colon when using GAS.
	(ASM_OUTPUT_INTERNAL_LABEL): Define.

2007-01-10  Ralf Corsépius <ralf.corsepius@rtems.org>

	* config/bfin/t-bfin, config/bfin/t-bfin-elf: Remove GCC_CFLAGS.

2007-01-09  Nicolas Pitre  <nico@cam.org>

	PR target/30173
	* arm/ieee754-df.S (Lad_s): Also test the low word of X for zero.

2007-01-08  Nick Clifton  <nickc@redhat.com>

	* config/frv/predicates.md (reg_or_0_operand): Accept
	CONST_DOUBLEs.

2007-01-08  Ralf Corsépius <ralf.corsepius@rtems.org>

	* config/bfin/rtems.h, config/bfin/t-rtems: New.
	* config.gcc: Add bfin*-rtems*.

2007-01-08  Chen liqin  <liqin@sunnorth.com.cn>
	* config/score/t-score-elf (MULTILIB_OPTIONS): Change.
	* config/score/predicates.md (const_uimm5, sr0_operand, const_simm12,
	const_simm15, const_pow2, const_npow2): Added.
	* config/score/misc.md (insv, extv, extzv, movmemsi,
	move_lbu_a/b, mov_lhu_a/b etc): Added and fix some bug.
	* config/score/score.c (score_address_cost, score_select_cc_mode):
	Added.
	Change CONST_OK_FOR_LETTER_P/EXTRA_CONSTRAINT define.
	Update score_rtx_costs for MACRO TARGET_RTX_COSTS.
	Update score_print_operand.
	* config/score/score.h (DATA_ALIGNMENT, SELECT_CC_MODE): Added.
	Adjust register allocate order and update some macro define.
	* config/score/score-mdaux.c (mdx_unaligned_load, mdx_unsigned_store,
	mdx_block_move_straight, mdx_block_move_loop_head,
	mdx_block_move_loop_body, mdx_block_move_loop_foot, mdx_block_move_loop,
	mdx_block_move): Added.
	(mdx_movsicc, mdp_select_add_imm, mdp_select, mds_zero_extract_andi,
	mdp_limm): Updated and fix some bug and typo.
	* config/score/score.md (movqi/hi/si, add/sub/zero/ext): Updated.
	(movsf, movdf, doloop_end): Added.

2007-01-05  Richard Guenther  <rguenther@suse.de>

	PR middle-end/27826
	* tree.c (get_narrower): Do not construct COMPONENT_REFs
	with mismatched types.  Instead explicitly build a
	conversion NOP_EXPR.

2007-01-05  Jakub Jelinek  <jakub@redhat.com>

	PR c/30360
	* libgcc2.c (__divdc3): Compare c and d against 0.0 instead of
	denom against 0.0.

2007-01-03  Jakub Jelinek  <jakub@redhat.com>

	* unwind-dw2.c (SIGNAL_FRAME_BIT, EXTENDED_CONTEXT_BIT): Define.
	(struct _Unwind_Context): Rename args_size to flags, remove
	signal_frame field, add a new args_size field and version field.
	(_Unwind_IsSignalFrame, _Unwind_SetSignalFrame,
	_Unwind_IsExtendedContext): New inline functions.
	(_Unwind_GetGR, _Unwind_SetGR, _Unwind_GetGRPtr, _Unwind_SetGRPtr):
	Assume by_value array is only present if _Unwind_IsExtendedContext.
	(_Unwind_GetIPInfo, execute_cfa_program, uw_frame_state_for): Use
	_Unwind_IsSignalFrame.
	(__frame_state_for): Initialize context.flags to EXTENDED_CONTEXT_BIT.
	(uw_update_context_1): Use _Unwind_SetSignalFrame.
	(uw_init_context_1): Initialize context->flags to
	EXTENDED_CONTEXT_BIT.
	* config/rs6000/linux-unwind.h (frob_update_context): Use
	_Unwind_SetSignalFrame.

2007-01-01  Mike Stump  <mrs@apple.com>

	* configure.ac: Remove support for building with Apple's gcc-3.1.

2007-01-01  Andreas Schwab  <schwab@suse.de>

	PR target/29166
	* config/ia64/ia64.c (ia64_compute_frame_size): Account space for
	save of BR0 in extra_spill_size instead of spill_size.
	(ia64_expand_prologue): Save BR0 outside of the gr/br/fr spill
	area.
	(ia64_expand_epilogue): Restore BR0 from its new location.
